// va in crash [oid:8000003a,prio:2] PPM::PWM Limit Over!! PRM:/r2/c1-Joint2:21 // LFLEG J1 (Left Front Leg)
//quando crascia per motion!

#include "EventMgr.h"
#include <OPENR/OSyslog.h>
#include <OPENR/core_macro.h>
#include <OPENR/OPENRAPI.h>
#include "entry.h"
#include "../Motion/MotionInterface.h"
#include "../utils/utils.h"
#include <../lib/AiboEdgeDetector/AiboEdgeDetector.h>
#include<../lib/AISColorSeg/AISAiboYCrCbColorSeg.h>
#include<../lib/info_ball/info_ball.h>
//#include<../lib/iuriFit/CircleFittingClass.h>
#include <math.h>
#include <../lib/matrix/matrix.h>


//salvataggio immagini
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <OPENR/ODataFormats.h>
#include <OPENR/OFbkImage.h>
//#include "ImageObserver.h"
#include "../utils/BMP.h"
 


#define PI 3.14159265

#ifndef _NO_NAMESPACE
using namespace std;
using namespace math;
#define STD std
#else
#define STD
#endif

#ifndef _NO_TEMPLATE
typedef matrix<double> Matrix;
#else
typedef matrix Matrix;
#endif


#ifndef _NO_EXCEPTION
#  define TRYBEGIN();	try {
#  define CATCHERROR();	} catch (const STD::exception& e) { \
						cerr << "Error: " << e.what() << endl; }
#else
#  define TRYBEGIN();
#  define CATCHERROR();
#endif

EventMgr::EventMgr(): fbkID(oprimitiveID_UNDEF),
			 initSensorIndex(false),
			 sensorRegions(),
			 lastRefPan(0),
			 lastRefTilt(0)
{
  for (size_t i = 0; i < NUM_SENSORS; i++){
      jointID[i] = oprimitiveID_UNDEF;
      sensoridx[i] = -1;
  }
  res.neckAngle.pan = -300;
  res.neckAngle.tilt = -300;
  res.neckAngle.tilt2 = -300;
  res.centroide.x = 0;
  res.centroide.y = 0;
  codaStati.push(1);
  timeoneshot = 0;
  width = 208;
  height = 160; 
  numImmaginiDaUltimoFrameProcessato=0;
  numImmagini = 0;
  seg = new AISAiboYCrCbColorSeg(width,height);
  edge = new AiboEdgeDetector(width, height);
  numLineeCampo = 0; //linee identificate 
  DelayAction = 0;//tempo che deve intercorrere tra il tuffo e l'azione stay neutral
  prevFrameDistance = 99999; 
 
}

OStatus EventMgr::DoInit(const OSystemEvent& event){
  OSYSDEBUG(("EventMgr::DoInit()\n"));
  NEW_ALL_SUBJECT_AND_OBSERVER;
  REGISTER_ALL_ENTRY;
  SET_ALL_READY_AND_NOTIFY_ENTRY;
  OStatus st = OPENR::SetMotorPower(opowerON);
  OpenPrimitives();
  SetCameraParameter();
  
  //creo gli oggetti per la segmentazione e per l'edge detection
  
  //alloco l'array per contenere rho theta e 
  lineeCampo = (int**) calloc(3,sizeof(int*)); //alloco la memoria 
  if (lineeCampo == NULL) while(1) OSYSDEBUG(("4")); //exit (2);
  for(int t=0;t<=3;t++){ //alloco la memoria per ogni riga
    lineeCampo[t] = (int*) calloc(3,sizeof(int));
    if (lineeCampo[t] == NULL) while(1) OSYSDEBUG(("5")); //exit (2);
  }
  if (lineeCampo == NULL) while(1) OSYSDEBUG(("6")); //exit (2);
  //Cb Cr per la linea  bianca
  //unsigned char CbMin = 110;//130;
  //unsigned char CrMin = 64;//74;
  //unsigned char CbMax = 180;//160;
  //unsigned char CrMax = 137;//107;
  
  //Cb Cr per la palla
  /*
  //uni / nuvoloso
  unsigned char CbMin = 125; //130;//ale
  unsigned char CrMin = 160; //145;//ale
  unsigned char CbMax = 140;//180;//ale
  unsigned char CrMax = 240; //255;//ale
  */

  //uni / nuvoloso
  unsigned char CbMin = 90; //130;//ale
  unsigned char CrMin = 160; //145;//ale
  unsigned char CbMax = 170;//180;//ale
  unsigned char CrMax = 255; //255;//ale

  
  //lab sera 16:30
  // unsigned char CbMin = 130;
  //unsigned char CrMin = 170;
  //unsigned char CbMax = 180;
  //unsigned char CrMax = 255;
  //imposto il colore delle linee (aggiungendo la liminosita')
  for(int i=0;i<254;i++){
    seg->setColor(AISAiboYCrCbColorSeg::l0, i, CrMin,CrMax,CbMin,CbMax);//y,cr-min cr-max cb-min cb-max
  }

  prevBallDistance = (double*) calloc(NUM_BALL_DISTANCE,sizeof(double));
  if (prevBallDistance == NULL) while(1) OSYSDEBUG(("5")); //exit (2);

  ballLocation = (ballLocationStruct*) calloc(NUM_BALL_LOCATION*2,sizeof(int));
  if (ballLocation == NULL) while(1) OSYSDEBUG(("5")); //exit (2);

  prevBallDiameter = (double*) calloc(NUM_MEDIA_DIAMETRI,sizeof(double));
  if (prevBallDiameter == NULL) while(1) OSYSDEBUG(("5")); //exit (2);

  for(int i = 0;i< NUM_BALL_DISTANCE;i++ )  prevBallDistance[i] = -1;
  for(int i = 0;i< NUM_BALL_LOCATION;i++ ) { ballLocation[i].x = NUM_BALL_DISTANCE_NOT_VALID_VALUE; ballLocation[i].y = NUM_BALL_DISTANCE_NOT_VALID_VALUE;}
  for(int i = 0;i< NUM_MEDIA_DIAMETRI;i++ )  prevBallDiameter[i] = -1;
  return oSUCCESS;
}


/*DoStart: fa partire Telepati*/
OStatus EventMgr::DoStart(const OSystemEvent& event){
  OSYSDEBUG(("EventMgr::DoStart()\n"));
  ENABLE_ALL_SUBJECT;
  ASSERT_READY_TO_ALL_OBSERVER;
  
  int dummy=0;
  EventID sincroEvent = EventID();
  RelativeTime period(1, 0);
  TimeEventInfoWithRelativeTime timeInfo(TimeEventInfo::Periodic, period);
  sError error=SetTimeEvent(&timeInfo,myOID_,Extra_Entry[entryTimerEnd],&dummy,sizeof(dummy),&sincroEvent);
  if(error!=sSUCCESS) OSYSLOG1((osyslogERROR, "::DoStart() : ERROR: Sincronization Timer not started\n"));
  
  return oSUCCESS;
}  //DoStart() END


void EventMgr::TimerEnd(void* msg){
  //PRN(("EventMgr:: Lo stato attuale e' > %d\n",state));
  // EventMgr::UpdateState();
  clock++;
  //PRN(("EventMng:: CLOCK> %d\n",clock));
  //subject[sbjSendState]->SetData(&(state),sizeof(int));
  //subject[sbjSendState]- cannot convert `double' to `int*' in assignm>NotifyObservers();  
}
/*
void EventMgr::UpdateState(){
  if(!codaStati.empty()){
    state = codaStati.front();
    codaStati.pop();
  }else codaStati.push(0);
}
*/

void EventMgr::NotifyImage(const ONotifyEvent& event){
  OFbkImageVectorData* imageVec = reinterpret_cast<OFbkImageVectorData*>(const_cast<void*>(event.Data(0)));
  //salvo le ultime posizioni del collo e poi le passo a RLib
  OFbkImageInfo* info = imageVec->GetInfo(ofbkimageLAYER_C);
  GetPanTiltAngle(info->frameNumber, &res.neckAngle.pan, &res.neckAngle.tilt2, &res.neckAngle.tilt);
  byte* data;
  if(imageVec!=NULL) data = imageVec->GetData(ofbkimageLAYER_H);
  //segmento l'immagine in formato ycbcr Aibo Raw
  const unsigned int* ptr = NULL;
  int numpixelpalla = 0;
  double ballDistance = 0;
  double* infoBall = NULL;
  int sxCentroDx = -1000; //valore nn valido
  double timeToImpact;
  double mediaDiametri;
  Matrix versoreDirezPalla(3,1),coordinatePalla(3,1);
 
  /*
  // da cancellare
  printf("tuffo a sx ***************\n");
  state = 3;
   subject[sbjSendState]->SetData(&(state),sizeof(int));
   subject[sbjSendState]->NotifyObservers();
   state = 1;
   printf("in piedi ***************\n");
   subject[sbjSendState]->SetData(&(state),sizeof(int));
   subject[sbjSendState]->NotifyObservers();
  */
 //fine da cancellare
  //state = prevState;//??????????????????
   
  //m3 = m1 + m2;
  //printf("matrice1 %f,%f,%f,%f\n", m1(0,0), m1(0,1), m1(1,0), m1(1,1));
  //printf("matrice2 %f,%f,%f,%f\n", m2(0,0), m2(0,1), m2(1,0), m2(1,1));
  //printf("matrice3 %f,%f,%f,%f\n", m3(0,0), m3(0,1), m3(1,0), m3(1,1));
  //CATCHERROR(); 
  //printf("*** immagine\n");
  if(data != NULL){
    ptr = seg->processImage(static_cast<unsigned char*>(data));
    //if(ptr != NULL) OSYSDEBUG(("**************************************** immagine segmentata con successo!!!  **********************************************************\n"));
  }else OSYSDEBUG(("EventMgr: **************************************** immagine NON segmentata !  **********************************************************\n"));
  
  if(state == 6){ //se e' in tuffo
    DelayAction++;
    if(DelayAction > 200) {
      prevState = state;
      state = 1;
      
      subject[sbjSendState]->SetData(&(state),sizeof(int));
      subject[sbjSendState]->NotifyObservers();
      DelayAction = 0;
      //printf("EventMgr: DelayAction > 199  / mando lo stato(1)|| state> %d,%d\n",prevState,state);
    }
    if(DelayAction == 80) {//delay dell'azione che sto eseguendo
      state = 6;
      prevState = state;
      subject[sbjSendState]->SetData(&(state),sizeof(int));
      subject[sbjSendState]->NotifyObservers();
      //printf("EventMgr: DelayAction == 80 / mando lo stato(6) in esecuzione||state> %d,%d\n",prevState,state);
    }
    //segue la palla con la testa mentre e' in crunch 
    if((ptr != NULL && ( numpixelpalla =  seg->getNumberOfRecognizedPixel(AISAiboYCrCbColorSeg::l0)) > 35) && (DelayAction > 0)){
      infoBall  =  info_ball(ptr);
      if (infoBall != NULL){
	mediaDiametri = calcoloDiametroMedio();
	if(mediaDiametri != -1)  ballDistance = /*12750.0*/ 13440/mediaDiametri; //in millimetri
	if(ballDistance >= /*12750*/13440) ballDistance = -1;
	//printf("BallDistanceMedia> %f, Balldistance> %f\n",ballDistance,12750.0/infoBall[0]);
	res.centroide.x = infoBall[1];
	res.centroide.y = infoBall[2];
	subject[sbjSendinfo]->SetData(&(res),sizeof(RLibInfo));
	subject[sbjSendinfo]->NotifyObservers();
	state = 2;
	subject[sbjSendState]->SetData(&(state),sizeof(int));
	subject[sbjSendState]->NotifyObservers();
	state = 6;
	//printf("EventMgr: *DelayAction* mando lo stato(2) in esecuzione||state> %d,%d\n",prevState,state);
      }
    }
    //PRN(("%d",DelayAction));
  }else{//se nn e' in tuffo
    //cerco il centroide della palla se ci sono piu' di 35 pixel rosa
    //printf("EventMgr: pixel palla -> %d\n",seg->getNumberOfRecognizedPixel(AISAiboYCrCbColorSeg::l0));
    if(ptr != NULL && ( numpixelpalla =  seg->getNumberOfRecognizedPixel(AISAiboYCrCbColorSeg::l0)) > 35){
      infoBall  =  info_ball(ptr);
      if (infoBall != NULL){
	mediaDiametri = calcoloDiametroMedio();
	if(mediaDiametri != -1)  ballDistance = /*12750*/13440/mediaDiametri; //in millimetri
	if(ballDistance >= /*12750*/13440) ballDistance = -1;
	//printf("BallDistanceMedia> %f, Balldistance> %f\n",ballDistance,12750.0/infoBall[0]);
	int near;
	int far;
	res.centroide.x = infoBall[1];
	res.centroide.y = infoBall[2];
	//scatta delle foto di immagini predeterminate
	//if(numImmagini == 300 ||numImmagini == 1200 ||numImmagini == 900 ||numImmagini == 600) SaveData(numImmagini,imageVec);
	//numImmagini++;
	//printf("EventMgr: centroide -> x= %d, y= %d\n",res.centroide.x,res.centroide.y);
	TRYBEGIN();
	//calcolo il versore che punta dal centro degli assi (che si trovano in centro all'immagine) verso il la palla
	versoreDirezPalla(0,0) = (double) res.centroide.x - CENTRO_X; //asse x	
	versoreDirezPalla(1,0) = (double) FOCALE_PX; //asse y
	versoreDirezPalla(2,0) = (double) res.centroide.y - CENTRO_Y; //asse z
	//	printf("versP(%f %f %f\n)",versoreDirezPalla (0,0), versoreDirezPalla(1,0), versoreDirezPalla(2,0));
	versoreDirezPalla = versoreDirezPalla / sqrt((pow(versoreDirezPalla(0,0),2) + pow(versoreDirezPalla(1,0),2) + pow(versoreDirezPalla(2,0),2)));//normalizzo
	//trovo il vettore palla
	coordinatePalla = versoreDirezPalla * ballDistance;
	
	//printf("%f %f %f %f\n",versoreDirezPalla (0,0), versoreDirezPalla(1,0), versoreDirezPalla(2,0),ballDistance);
	
	//printf("direzionePalla           %f,%f,%f\n", coordinatePalla(0,0), coordinatePalla(1,0), coordinatePalla(2,0));
	rotoTraslazioneVettorePalla(&coordinatePalla,res.neckAngle);
	//printf("direzionePalla traslata  %f,%f,%f\n", coordinatePalla(0,0), coordinatePalla(1,0), coordinatePalla(2,0));
	//printf("%f %f %f %f\n",coordinatePalla(0,0), coordinatePalla(1,0), coordinatePalla(2,0),infoBall[0]);
	//printf("----------------------------------------\n");
	CATCHERROR(); 
	
	if(TimeToImpact(&sxCentroDx,&timeToImpact) == 1);// printf("sx-dx> %d, TTI> %lf\n",sxCentroDx,timeToImpact);
	//else printf("timeToImpact NON valido\n");

	
	//printf("Distanza> %d\n",ballDistance);
	if(res.neckAngle.pan!=-300){ //se ho calcolato un pan del collo..se no e' successo qlcosa di imprevisto!
	  //printf("EventMgr: centroide -> x= %f, y= %f\n",res.centroide.x,res.centroide.y);
	  /*
	  

	  //tuffo con il calcolo della ball distance
	  //printf("EventMgr: Media Diametri> %f\n",calcoloDiametroMedio());
	  if(ballDistance != -1 && ballDistance < 250 && prevFrameDistance != - 1 && prevFrameDistance < 250){ // se e' + vicino di 25cm ed era ] vicino di 30cm anche il frame scorso 
	    
	    //printf("EventMgr: abs(distanza laterale) =  %f centroide -> x= %d, y= %d\n",res.centroide.x,res.centroide.y,cos(res.neckAngle.pan)*ballDistance);
	    //printf("EventMgr: abs(distanza laterale) =  %f, centroide -> x= %d, y= %d,pan= %f, distanza= %d\n",sin((res.neckAngle.pan*PI)/180)*ballDistance,res.centroide.x,res.centroide.y,res.neckAngle.pan,ballDistance);
	    if(abs(sin((res.neckAngle.pan*PI)/180)*ballDistance) > 100){ //se la palla e' + lontana di 10cm dalla perperdicolare rispetto al cane (cosi che' puo' allungare la zampa e prenderla)
	      if(res.neckAngle.pan > 0) state = 3;//se e' a sx
	      else state = 5;// se e' a dx
	    }else state = 4; //se no buttati al centro xe' la palla nn e' distante lateralmente.
 printf("EventMgr: DelayAction == 60 / mando lo stato(6) in esecuzione||state> %d,%d\n",prevState,state);	  }else{//se la distanza e' >= 30 oppure nn ho trovato 1 distanza
	    if(prevFrameDistance > 250){//se per 2 frame di fila la distanza e' maggiore di 25cm 
	      if(prevState >=3 ) state = 7;
	      else state = 2;
	    }
	  }
	*/
	  //tuffo con il calcolo del TTI

	  //printf(" prevTTI> %f centr.x> %d, y>%d\n",prevTimeToImpact, res.centroide.x, res.centroide.y);
	  if(timeToImpact != -1 && timeToImpact < 30 && prevTimeToImpact != -1 && prevTimeToImpact < 30 && res.centroide.x > 60 && res.centroide.y > 60 && res.centroide.x < 140 && res.centroide.y < 120){ // se il TTI e' minore di X frame e pure il TTi del frame scorso allora..
	    //printf("EventMgr: abs(distanza laterale) =  %f centroide -> x= %d, y= %d\n",res.centroide.x,res.centroide.y,cos(res.neckAngle.pan)*ballDistance);
	    //printf("EventMgr: abs(distanza laterale) =  %f, centroide -> x= %d, y= %d,pan= %f, distanza= %d\n",sin((res.neckAngle.pan*PI)/180)*ballDistance,res.centroide.x,res.centroide.y,res.neckAngle.pan,ballDistance);
	    // printf("tuffo\n");

	    // printf("sx-dx> %d, TTI> %lf\n",sxCentroDx,timeToImpact);
    
	    if(sxCentroDx == -1) state = 3;//se e' a sx
	    else{
	      if(sxCentroDx == 1) state = 5;// se e' a dx
	      else state = 4; //se no buttati al centro xe' la palla nn e' distante lateralmente.
	    }

	  }else{//se tti  e' >= 30 oppure nn ho trovato 1 tti
	    //if(prevTimeToImpact > 30){//se per 2 frame di fila la distanza e' maggiore di 25cm 
	    if(prevState >=3) state = 7;
	    else state = 2;
	    //}
	  }

	  //fake per nn far spegnere (fam) l'aibo
	  if((prevState == 3 || prevState == 5) && prevState != state) state = 6;//fake state
      
	  //Manda informazioni angoli collo a RLib per seguire la palla
	  //se lo stato e' != al precedete oppure e'2, nn vado in NEUTRAL da 1 tuffo, e nn mi tuffo da 1 BLOCK_C
	  //if(state != 2) printf("EventMgr:|state> %d,%d\n",prevState,state);
	  if((prevState != state || state == 2 || state == 7) && !(prevState==4 && (state==3||state==5)) && (state!=6) ){
	    prevState = state;
	    subject[sbjSendinfo]->SetData(&(res),sizeof(RLibInfo));
	    subject[sbjSendinfo]->NotifyObservers();
	    //Manda stato a RLib per far partine 1 azione
	    //if(state != 2) printf("EventMgr: Eseguo l'azione******* %d *********\n",state);
	    subject[sbjSendState]->SetData(&(state),sizeof(int));
	    subject[sbjSendState]->NotifyObservers();
	  }
	}
      }
    }else { //non ho trovato la palla
      //printf("EventMgr: *Palla non trovata!*\n");
      prevFrameDistance = -1;
      if(/*state != 1 && */ numImmaginiCercaPalla > NUM_IMMAGINI_CERCA_PALLA) { //se lo stato precedente non era 1 (cerca palla) allora fai cercare la palla
	//printf("EventMgr: *Palla persa!* \n");
	if(state == 3 || state == 5) state = 6;
	else state =1;
	if(prevState != state & state != 6){
	  prevState = state;
	  //PRN(("EventMng:: invio a RGen  lo stato-> %d\n",state));
	  subject[sbjSendState]->SetData(&(state),sizeof(int));
	  subject[sbjSendState]->NotifyObservers();
	}
	numImmaginiCercaPalla = 0; //riparto da 0 a contare
      }else numImmaginiCercaPalla++;
    }
  }
  //	printf("EventMgr:3- diametro> %f, %d\n",infoBall[0],infoBall[0]);
  //faccio sciftare tt le distanze dei vecchi frame di uno e aggiungo il nuovo alla fine (cagata, usare una lista)  
  for(int i = 0;i< NUM_BALL_DISTANCE;i++ ){
    if(i!=NUM_BALL_DISTANCE - 1) prevBallDistance[i] = prevBallDistance[i+1];//printf("prevBallDistance[%d] = %d || ",i,prevBallDistance[i]);}
    else{//se e' l'ultimo
      if(ballDistance != -1) prevBallDistance[i] = ballDistance;
      else  prevBallDistance[i] = -1;
    }
  }
  //printf("EventMgr: 4- diametro> %f, %d\n",infoBall[0],infoBall[0]);
 //faccio sciftare tt i diametri dei vecchi frame di uno e aggiungo il nuovo alla fine (cagata, usare una lista)  
  for(int i = 0;i< NUM_MEDIA_DIAMETRI;i++ ){
    if(i!=NUM_MEDIA_DIAMETRI - 1) prevBallDiameter[i] = prevBallDiameter[i+1];//printf("prevBallDistance[%d] = %d || ",i,prevBallDistance[i]);}
    else{//se e' l'ultimo
      // if(infoBall != NULL) printf("EventMgr:5- diametro> %f\n",infoBall[0]);
      if(infoBall != NULL) prevBallDiameter[i] = infoBall[0];// printf("infoBall[0]> %f \n",prevBallDiameter[i]);}
      else  prevBallDiameter[i] = -1;
    }
  }
 //printf("prevBallDistance[4] = %d \n",prevBallDistance[4]); 
  for(int i = 0;i<NUM_BALL_LOCATION;i++) {
    if(i!=NUM_BALL_LOCATION-1){ 
      ballLocation[i].x = ballLocation[i+1].x;
      ballLocation[i].y = ballLocation[i+1].y;
      //printf("ballLocation[%d].x = %d, y = %d, ",i,ballLocation[i].x,ballLocation[i].y);
    }else{
      if(infoBall != NULL && res.neckAngle.pan!=-300 ){//&& ballDistance != -1){
	
	TRYBEGIN();
	ballLocation[i].x = (int)(coordinatePalla(0,0)+0.5);//sin((res.neckAngle.pan*PI)/180)*ballDistance;//distanza laterale
	ballLocation[i].y = (int)(coordinatePalla(1,0)+0.5);//cos((res.neckAngle.pan*PI)/180)*ballDistance;//distanza frontale
	//findBallLocation(&ballLocation[i].x,&ballLocation[i].y,res,ballDistance);//metto in .x e .y i valori di x e di y della palla
	//printf("ballLocation[%d].y = %d, x = %d\n",i,ballLocation[i].y,ballLocation[i].x);
	CATCHERROR(); 
      }
      else {
	ballLocation[i].x = NUM_BALL_DISTANCE_NOT_VALID_VALUE; //valore non valido
	ballLocation[i].y = NUM_BALL_DISTANCE_NOT_VALID_VALUE; //valore non valido
      }
    }
  }
  //printf("\n");
  if(ballDistance > 0) prevFrameDistance = ballDistance; //aggiorna la distanza xe' il prossimo frame possa saxla
  prevTimeToImpact = timeToImpact; //salvo il tti del precedente frame
  observer[event.ObsIndex()]->AssertReady();
}



double EventMgr::rotoTraslazioneVettorePalla(Matrix *vettorePalla,NeckAngle angoliAibo){
  
  //creazione matrici di rototraslazione
  
  Matrix r1(3,3), r2(3,3), r3(3,3);
  //angoliAibo.tilt2 -= 30;
  // angoliAibo.tilt -= 20;
  //angoliAibo.tilt2 *= -1;
  //angoliAibo.tilt *= -1;
  //angoliAibo.pan *= -1;

  TRYBEGIN();
  //questa matrice serve per traslare gli assi dal muso al cervello dell'aibo, senza ruotare gli assi
  r1(0,0) = 1.0;
  r1(0,1) = 0.0;
  r1(0,2) = 0.0;
  //-----------
  r1(1,0) = 0.0;
  r1(1,1) = cos((angoliAibo.tilt2*PI)/180);
  r1(1,2) = -(sin((angoliAibo.tilt2*PI)/180));
  //------------
  r1(2,0) = 0.0;
  r1(2,1) = sin((angoliAibo.tilt2*PI)/180);
  r1(2,2) = cos((angoliAibo.tilt2*PI)/180);
  
  //questa matrice serve per 
  r2(0,0) = cos((angoliAibo.pan*PI)/180);
  r2(0,1) = -(sin((angoliAibo.pan*PI)/180));
  r2(0,2) = 0.0;
  //-----------
  r2(1,0) = sin((angoliAibo.pan*PI)/180);
  r2(1,1) = cos((angoliAibo.pan*PI)/180);
  r2(1,2) = 0.0;
  //------------
  r2(2,0) = 0.0;
  r2(2,1) = 0.0;
  r2(2,2) = 1.0;
 
  //questa matrice serve per 
  r3(0,0) = 1.0;
  r3(0,1) = 0.0;
  r3(0,2) = 0.0;
  //-----------
  r3(1,0) = 0.0;
  r3(1,1) = cos((angoliAibo.tilt*PI)/180);
  r3(1,2) = -(sin((angoliAibo.tilt*PI)/180));
  //------------
  r3(2,0) = 0.0;
  r3(2,1) = sin((angoliAibo.tilt*PI)/180);
  r3(2,2) = cos((angoliAibo.tilt*PI)/180);
  //----------
  //traslazione asse y di LUNGHEZZA_TESTA
  (*vettorePalla)(1,0) = (*vettorePalla)(1,0) + LUNGHEZZA_TESTA;
  // printf("direzionePalla           %f,%f,%f\n",(*vettorePalla)(0,0),(*vettorePalla)(1,0), (*vettorePalla)(2,0));
  //traslazione asse z per camera +bassa dell'asse del join
  (*vettorePalla)(2,0) = (*vettorePalla)(2,0) - 14.6; //mettere 1 costante **********************
  //rotazione su asse x di tilt2 gradi
  *vettorePalla = r1 * *vettorePalla;
  // printf("direzionePalla           %f,%f,%f - tilt2>%f\n",(*vettorePalla)(0,0),(*vettorePalla)(1,0), (*vettorePalla)(2,0),angoliAibo.tilt2);
  //rotazione su asse z di pan gradi
  *vettorePalla = r2 * *vettorePalla;
  // printf("direzionePalla           %f,%f,%f - pan>%f\n",(*vettorePalla)(0,0),(*vettorePalla)(1,0), (*vettorePalla)(2,0), angoliAibo.pan);
  //traslazione su asse z di DISTANZA_PETTO_TESTA
  (*vettorePalla)(2,0) = (*vettorePalla)(2,0) + DISTANZA_PETTO_TESTA;
  // printf("direzionePalla           %f,%f,%f\n",(*vettorePalla)(0,0),(*vettorePalla)(1,0), (*vettorePalla)(2,0));
  //rotazione asse x di tilt gradi
  *vettorePalla = r3 * *vettorePalla;
  //printf("direzionePalla           %f,%f,%f - tilt>%f\n",(*vettorePalla)(0,0),(*vettorePalla)(1,0), (*vettorePalla)(2,0), angoliAibo.tilt);

  // printf("  | %f,%f,%f|\n", r1(0,0), r1(0,1), r1(0,2));
  //printf("r1| %f,%f,%f|\n", r1(1,0), r1(1,1), r1(1,2));
  // printf("  | %f,%f,%f|\n", r1(2,0), r1(2,1), r1(2,2));
  //printf("  | %f,%f,%f|\n", r2(0,0), r2(0,1), r2(0,2));
  //printf("r2| %f,%f,%f|\n", r2(1,0), r2(1,1), r2(1,2));
  //printf("  | %f,%f,%f|\n", r2(2,0), r2(2,1), r2(2,2));
  //printf("  | %f,%f,%f|\n", r3(0,0), r3(0,1), r3(0,2));
  //printf("r3| %f,%f,%f|\n", r3(1,0), r3(1,1), r3(1,2));
  //printf("  | %f,%f,%f|\n", r3(2,0), r3(2,1), r3(2,2));
  //angoliAibo.tilt += 20;
  CATCHERROR(); 
}


double EventMgr::calcoloDiametroMedio(){
  double mediaDist = 0;
  int numValidY = 0;
  //printf("media Diametro> ");
  for(int i = 0;i<NUM_MEDIA_DIAMETRI;i++) { //scorro l'arrai dal secondo membro fino al penultimo menbro che verra' comparato con l'ultimo in automatico
    if(prevBallDiameter[i] != -1){ //se e' valido
      //printf("prec VelMedia->%f,ballLocation[i+1].y->%d, ballLocation[i].y->%d, velMedia calcolata-> ",velMedia,ballLocation[i+1].y,ballLocation[i].y);
      numValidY++;
      //printf("%f ",prevBallDiameter[i]);
      mediaDist += prevBallDiameter[i];
    }
  }
  if(numValidY > 0){
    mediaDist /= (double)numValidY;
    //  printf("-->* %f *\n",mediaDist);
    return mediaDist;
  }else return -1;
}


//calcolo il tempo in secondi e lo metto in timetoimpact, e calcolo se cadr' a sx o destra e lo metto in sxCentroDx retituisco 0 se e' andato a buon fine
//se sxCentroDx e'>0  significa dx se e' <0 significa sx se e' 0 significa centro
int  EventMgr::TimeToImpact(int* sxCentroDx,double* timeToImpact){
  double posizFinaleX;
  double velMediaY = calcoloVelMediaY();
  double velMediaX = calcoloVelMediaX();
  // velMediaY = -velMediaY;//correzione direzione, dopo il cambiamento di riferimento dell'asse y,giusto per nn cambiare tt il programma ;)
  


  //tre righe da cancellare 
  //*timeToImpact =abs(ballLocation[NUM_BALL_LOCATION].y / velMediaY); //xe' la velocita' calcolata e' all'instante NUM_BALL_LOCATION/2 e non t0
  //*sxCentroDx = 0;
  //return 1;



  //  printf("*** Y -> %f \n",velMediaY);
  // printf("location.y> %d\n",ballLocation[(int)((NUM_BALL_LOCATION/2.0)+0.5)].y);
  *timeToImpact = -1;
  if(velMediaY != 0 && (ballLocation[(int)((NUM_BALL_LOCATION/2.0)+0.5)].x != NUM_BALL_DISTANCE_NOT_VALID_VALUE) && (ballLocation[(int)((NUM_BALL_LOCATION/2.0)+0.5)].x != NUM_BALL_DISTANCE_NOT_VALID_VALUE)){ // se al tempo t1 nn ho tutte le informazioni della palla che mi servono ritorna 0
    if(velMediaY < 0){ //se la palla viene verso di me (sull'asse y)
      //calcolo il tempo di impatto
      *timeToImpact = abs((ballLocation[(int)((NUM_BALL_LOCATION/2.0)+0.5)].y)/velMediaY); //xe' la velocita' calcolata e' all'instante NUM_BALL_LOCATION/2 e non t0
      //calcolo dove impattera' sull'asse x
      if(ballLocation[(int)((NUM_BALL_LOCATION/2.0)+0.5)].x > 0){ //se la palla si trova a dx la velocita' della palla che viene verso di me e' negativa, altrimenti e'positiva
	if(velMediaX < 0){ //se sta venendo verso di me 
	  //printf("DX verso di me\n");
	  posizFinaleX = ballLocation[(int)((NUM_BALL_LOCATION/2.0)+0.5)].x + (*timeToImpact * velMediaX);
	  //printf("la palla cadra' sulle coordinate x> %f\n",posizFinaleX);
	  if(posizFinaleX > 0){ //se nn cambia lato
	    if(abs(posizFinaleX) < CENTIMETRI_TUFFO_AL_CENTRO) *sxCentroDx = 0; //centro
	    else *sxCentroDx = 1; //destra
	  }else{//se cambia lato
	    if(abs(posizFinaleX) < CENTIMETRI_TUFFO_AL_CENTRO) *sxCentroDx = 0; //centro 
	    else *sxCentroDx = -1; //sx
	  }
	}else *sxCentroDx = 1; //se sta andando lontano da me  (ed e' a dx significa che cadra' a dx qdi mi devo tuffare a dx
      }else{ //se la palla e' a sx e la velocita' della palla che viene verso di me e' negativa
	//**simmetrico a quello sopra, cambiano solo i segni**//
	//printf("SX verso di me\n");
	if(velMediaX > 0){ //se sta venendo verso di me 
	  posizFinaleX = ballLocation[(int)((NUM_BALL_LOCATION/2.0)+0.5)].x + (*timeToImpact * velMediaX);
	  //printf("la palla cadra' sulle coordinate x> %f\n",posizFinaleX);
	  if(posizFinaleX < 0){ //se nn cambia lato
	    if(abs(posizFinaleX) < CENTIMETRI_TUFFO_AL_CENTRO) *sxCentroDx = 0; //centro
	    else *sxCentroDx = -1; //sinistra
	  }else{//se cambia lato 
	    if(abs(posizFinaleX) < CENTIMETRI_TUFFO_AL_CENTRO) *sxCentroDx = 0; //centro
	    else *sxCentroDx = 1; //dx
	  }
	}else *sxCentroDx = -1; //se sta andando lontano da me  (ed e' a dx significa che cadra' a sx qdi mi devo tuffare a sx
      }
      return 1; //ho calcolato tutto quindi ritorno vero
    }else {
      //printf("ERRORE TTI> la palla sta andando lontano da me\n"); 
      return 0;
    } //la palla sta andando luntano da me sull'asse y quindi nn mi devo tuffare
  }else {
    //printf("ERRORE TTI> nn ho i dati\n"); 


  }
}


//calcolo velocita' Media con la posizione della palla dei frame precedenti e l'attuale
//presuppone minimo 2 frame si buffer (NUM_BALL_LOCATION >= 2)
double EventMgr::calcoloVelMediaY(){
  
  double velMediaY = 0;//NUM_BALL_DISTANCE_NOT_VALID_VALUE;
  double firstBlock = 0;
  double secondBlock = 0;
  int numValidY = 0;
  
  
  for(int i = 0;i<((NUM_BALL_LOCATION)/2);i++) { //scorro l'arrey dal secondo membro fino al penultimo menbro che verra' comparato con l'ultimo in automatico
    //printf("i=%d, ", i);
    if(ballLocation[i].y != NUM_BALL_DISTANCE_NOT_VALID_VALUE){ //se e' valido
      //printf("prec VelMedia->%f,ballLocation[i+1].y->%d, ballLocation[i].y->%d, velMedia calcolata-> ",velMedia,ballLocation[i+1].y,ballLocation[i].y);
      numValidY++;
      firstBlock += ballLocation[i].y;
    }
  }
  if(numValidY > 0) firstBlock /= (double)numValidY;
  numValidY = 0;
  // printf("\n");
  for(int i = (NUM_BALL_LOCATION)/2;i<NUM_BALL_LOCATION;i++){ //scorro l'arrei dal secondo membro fino al penultimo menbro che verra' comparato con l'ultimo in automatico
    // printf("i=%d, ", i);
    if(ballLocation[i].y != NUM_BALL_DISTANCE_NOT_VALID_VALUE){ //se e' valido
      //printf("prec VelMedia->%f,ballLocation[i+1].y->%d, ballLocation[i].y->%d, velMedia calcolata-> ",velMedia,ballLocation[i+1].y,ballLocation[i].y );
      numValidY++;
      secondBlock += ballLocation[i].y;
    
      //if(velMedia !=NUM_BALL_DISTANCE_NOT_VALID_VALUE )   velMedia = (velMedia + (ballLocation[i+1].y - ballLocation[i].y))/2;
      //else{
      //velMedia = ballLocation[i+1].y - ballLocation[i].y; //se la media nn e' ancora stata inserita metti il primo valore di velocita' calcolato
      // }
    
    }
  }
  // printf("\n");
  if(numValidY > 0) secondBlock /= (double)numValidY;
  if(secondBlock != NUM_BALL_DISTANCE_NOT_VALID_VALUE && firstBlock != NUM_BALL_DISTANCE_NOT_VALID_VALUE )  velMediaY =  (secondBlock - firstBlock)/ ((NUM_BALL_LOCATION)/2);
  

  // velMediaY = ballLocation[NUM_BALL_LOCATION].y - ballLocation[NUM_BALL_LOCATION-1].y;
  // printf("%f,%f  ***** velocita' media asse Y--> %f\n",firstBlock,secondBlock,velMediaY);
  //soglio da -1,5 a +1,5 come 0 in modo tale da stabilizzare la condizione di palla ferma
  //if(abs(velMediaY) <= SOGLIA_VEL_MAX_PALLA_FERMA) return 0;
  //else 
  return velMediaY;
 }

double EventMgr::calcoloVelMediaX(){
  
  double velMediaX = 0;//NUM_BALL_DISTANCE_NOT_VALID_VALUE;
  double firstBlock = 0;
  double secondBlock = 0;
  int numValidX = 0;
  

  for(int i = 0;i<((NUM_BALL_LOCATION)/2);i++) { //scorro l'arrei dal secondo membro fino al penultimo menbro che verra' comparato con l'ultimo in automatico
    //printf("i=%d, ", i);
    if(ballLocation[i].x != NUM_BALL_DISTANCE_NOT_VALID_VALUE){ //se e' valido
      //printf("prec VelMedia->%f,ballLocation[i+1].y->%d, ballLocation[i].y->%d, velMedia calcolata-> ",velMedia,ballLocation[i+1].y,ballLocation[i].y );
      numValidX++;
      firstBlock += ballLocation[i].x;
    }
  }
  if(numValidX > 0) firstBlock /= (double)numValidX;
  numValidX = 0;
  // printf("\n");
  for(int i = (NUM_BALL_LOCATION)/2;i<NUM_BALL_LOCATION;i++){ //scorro l'arrei dal secondo membro fino al penultimo menbro che verra' comparato con l'ultimo in automatico
    // printf("i=%d, ", i);
    if(ballLocation[i].x != NUM_BALL_DISTANCE_NOT_VALID_VALUE){ //se e' valido
      //printf("prec VelMedia->%f,ballLocation[i+1].y->%d, ballLocation[i].y->%d, velMedia calcolata-> ",velMedia,ballLocation[i+1].y,ballLocation[i].y );
      numValidX++;
      secondBlock += ballLocation[i].x;
    
      //if(velMedia !=NUM_BALL_DISTANCE_NOT_VALID_VALUE )   velMedia = (velMedia + (ballLocation[i+1].y - ballLocation[i].y))/2;
      //else{
      //velMedia = ballLocation[i+1].y - ballLocation[i].y; //se la media nn e' ancora stata inserita metti il primo valore di velocita' calcolato
  // }
    
    }
  }
  // printf("\n");
  if(numValidX > 0) secondBlock /= (double)numValidX;
  if(secondBlock != NUM_BALL_DISTANCE_NOT_VALID_VALUE && firstBlock != NUM_BALL_DISTANCE_NOT_VALID_VALUE )  velMediaX =  (secondBlock - firstBlock)/ ((NUM_BALL_LOCATION)/2);
  

   
  //printf("%f,%f  ***** velocita' media asse X--> %f\n",firstBlock,secondBlock,velMediaX);
 //soglio da -1,5 a +1,5 come 0 in modo tale da stabilizzare la condizione di palla ferma
  //if(abs(velMediaX) <=  SOGLIA_VEL_MAX_PALLA_FERMA) return 0;
  //else
  return velMediaX;
 }


void EventMgr::NotifySensor(const ONotifyEvent& event){
   //OSYSDEBUG(("EventMgr:: ricevuto un notifySensor\n"));
  RCRegion* rgn = event.RCData(0);
  
  if (initSensorIndex == false)  
    {
      OSensorFrameVectorData* sv = (OSensorFrameVectorData*)rgn->Base();
      InitSensorIndex(sv); 
      initSensorIndex = true;
    }
  
  if (sensorRegions.size() == NUM_SENSOR_VECTOR) 
    {
      sensorRegions.front()->RemoveReference();
      sensorRegions.pop_front();
    }
  rgn->AddReference();
  sensorRegions.push_back(rgn);
   
  // Aggiorno i valori degli angoli nella stuff cercata e prendo
  // il comando da mandare a motion
  //Motion::MotionCommand cmd=searchedStuff->search(*imageVec, pan ,tilt2, tilt);
  
  observer[event.ObsIndex()]->AssertReady();
}

void EventMgr::RLibInfoReady(const OReadyEvent& event){
}

void EventMgr::Ready(const OReadyEvent& event){
  //OSYSDEBUG(("EventMgr:: ricevuto Assert Ready\n"));
}
void EventMgr::ReadyMotion(const OReadyEvent& event){
  //OSYSDEBUG(("EventMgr:: ricevuto Assert Ready\n"));
}

//const unsigned int* image = matrice risultante dalla segmentazione, cioe' 1 matrice di interi unsigned che rappresentano i vari colori identificati (0 > colore nn trovato, 1 identificato il colore l0 ecc..)
//int numColore = numero del colore su cui applicare la trasformata di hough
//int height = altezza dell'immagine in pixel 
//int width = larghezza dell-immagine in pixel
//int sogliaEdge = soglia per gli edge delle linee
//int thetaInterval = numero di intervalli ogni 180 gradi,discretizzaziaone del theta
//int dInterval = numero di intervalli di rho,discretizzaziaone di rho
//const unsigned char* edgeImage = matrice con i gradienti dei pixel, risultato della funzione di edge-detector
//ritorna un array in cui array[0] rappresenta rho (in gradi) della retta trovata,array[1] rappresenta theta in gradi della retta trovata e array[2] rappresenta il numero di pixel della retta

int** EventMgr::trovoLineaPrincipaleHough(const unsigned int* image,unsigned int numColore,int height,int width,  int sogliaEdge, int thetaInterval,int dInterval,const unsigned char* edgeImage){
  int soglia = 45;
  int maxlineedarestituire = 6;
  int maxMatrix = 0;
  int linex=0,liney=0;
  //allocazione memoria per contenere l'array di accumulazione
  double d; //d nn ancora portato ad 1 valore per l'indice dell'accumulatore
  unsigned int** segment;
  segment = (unsigned int**) calloc(height,sizeof(unsigned int*));//creo 1 array di puntari
  if (segment == NULL) while(1) OSYSDEBUG(("0")); //exit (2);

  for(int t=0;t<height;t++) segment[t]=(unsigned int*)(&(image[width*t]));//creazione della matrice bidimens.faccio puntare ogni puntatore dell'array segment all'inizio di ogni riga

  //creazione array per lettura risultati dell'edge detections
  unsigned char** edgeArray;
  edgeArray = (unsigned char**) calloc(height,sizeof(unsigned char*));//puntatore che trasforma l'array monodimensionale in bidimensionale
  
  for(int t=0;t<height;t++) edgeArray[t]=(unsigned char*)(&(edgeImage[width*t]));//creazione della matrice bidimens. Del risultato del'edge detection
  if (edgeArray == NULL)  while(1) OSYSDEBUG(("1")); //exit (2);

  //impostazioni di rilevazione
  double thetaStep = 180/(double)thetaInterval;//gradi per ogni step di theta
  double dMax = sqrt(pow((double)width,2)+(pow((double)height,2)));//xe' va da -dmax a + dMax  
  double dStep = dMax*2/(double)dInterval;//lunghezza per ogni step
 
  int** a  = (int**) calloc(dInterval+1,sizeof(int*)); //alloco la memoria per una colonna
  if (a == NULL) while(1) OSYSDEBUG(("2")); //exit (2);
  for(int t=0;t<=dInterval;t++){ //alloco la memoria per ogni riga
    a[t] = (int*) calloc(thetaInterval,sizeof(int));
    if (a[t] == NULL) while(1) OSYSDEBUG(("3")); //exit (2);
  }
  
  //    if(numImmagini>=1) while(1);
  int numPuntiUtili = 0;
  int numerolinee=0;
  //scorro tutta la matrice delle segmentazione e dell'edge per trovare i punti utili
  for(int x = 0;x<width;x++){
    for(int y = 0;y<height;y++){
      //OSYSDEBUG(("%d ",edgeArray[y][x]));
      if((segment[y][x] == numColore) && (edgeArray[y][x] > sogliaEdge)){//se il pixel considerato e' su un bordo marcato e del colore della linea 
	//trovato il punto scrivo nella matrice di accumulo il fascio di rette
	numPuntiUtili++;
	for(int t=0;t<=thetaInterval;t++){ //p1er ogni punto faccio passare tutti i theta e calcolo tutti i d. //qui c'era 1 <=
	  d = (x*cos(((thetaStep*(double)t))*PI/180.0))+(y*sin(((thetaStep*(double)t))*PI/180.0));
	  a[(int)(floor(((double)(d+dMax)/dStep)+0.5))][t]++;//aggiungo dMax e moltiplico per 2 gli step xe' i valori di d vanno da -dMax a + dMax,io aggiungo 1 offset di dMax per avere tt positivi i valori
	  //questo calcola la linea principale
	  /*
	  //calcola il max della matrice,la mia linea del campo principale. 
	  if(maxMatrix < a[(int)(floor(((double)(d+dMax)/dStep)+0.5))][t]) {
	    maxMatrix = a[(int)(floor(((double)(d+dMax)/dStep)+0.5))][t];
	    linex = t;
	    //liney = (int)(floor(((double)(d+dMax)/dStep)+0.5));
	    liney = (int)d; //da cancellare 
	  }
	  */
	}//fine for theta
      }//fine if
    }//fine for h
    //OSYSDEBUG(("%d",segment[1][x]));
  }//fine for w
  //int* pcacca=(int*) malloc(maxlineedarestituire,sizeof(int*));
  

  int** pcacca  = (int**) calloc(maxlineedarestituire,sizeof(int*)); //alloco la memoria per una colonna
  if (pcacca == NULL) while(1) OSYSDEBUG(("2")); //exit (2);
  for(int t=0;t<=maxlineedarestituire;t++){ //alloco la memoria per ogni riga
    pcacca[t] = (int*) calloc(2,sizeof(int));
    if (pcacca[t] == NULL) while(1) OSYSDEBUG(("3")); //exit (2);
  }


  
  for(int x=0;x<thetaInterval;x++){
    for(int y=0;y<dInterval;y++){
      //se e' distante 2 dai pixel di edge
      //if((x>=2) and (x<=thetaInterval-2) and (y>=2) and (y<=dInterval-2)){//se e' abbastanza distante dai bordi
      // if((a[y][x] > soglia) /*numero di punti su 1 linea per considerarla retta*/ and ((a[y][x] > a[y-1][x-1]) and (a[y][x] > a[y-1][x]) and (a[y][x] > a[y-1][x+1]) and (a[y][x] > a[y][x+1]) and (a[y][x] > a[y+1][x+1]) and (a[y][x] > a[y+1][x]) and (a[y][x] > a[y+1][x-1]) and (a[y][x] > a[y][x-1]) /*aggiunta secondo pixel di distanza*/ and (a[y][x] > a[y-2][x-2]) and (a[y][x] > a[y-2][x-1]) and (a[y][x] > a[y-2][x]) and (a[y][x] > a[y-2][x+1]) and (a[y][x] > a[y-2][x+2]) and (a[y][x] > a[y-1][x-2]) and (a[y][x] > a[y-1][x+2]) and (a[y][x] > a[y][x-2]) and (a[y][x] > a[y][x+2]) and (a[y][x] > a[y+1][x-2]) and (a[y][x] > a[y+1][x+2]) and (a[y][x] > a[y+2][x-2]) and (a[y][x] > a[y+2][x-1]) and (a[y][x] > a[y+2][x]) and (a[y][x] > a[y+2][x+1]) and (a[y][x] > a[y+2][x-2]))){ fprintf(output,"%f %f\n",thetaStep*x,dStep*y-dMax);fprintf(output4,"%d -> %f %f\n",a[y][x],thetaStep*x,dStep*y-dMax);}
      //calcola i massimi locali con un intorno di 1.
      if((a[y][x] > soglia)/*numero di punti su 1 linea per considerarla retta*/ and ((a[y][x] > a[y-1][x-1]) and (a[y][x] > a[y-1][x]) and (a[y][x] > a[y-1][x+1]) and (a[y][x] > a[y][x+1]) and (a[y][x] > a[y+1][x+1]) and (a[y][x] > a[y+1][x]) and (a[y][x] > a[y+1][x-1]) and (a[y][x] > a[y][x-1]))){
	if(numerolinee < maxlineedarestituire){ //tengo conto solo delle prime sei linee che trovo
	  pcacca[numerolinee][0] = 1;
  	  pcacca[numerolinee][1] = 2;
	  //OSYSDEBUG(("linea %d: rho>%d, theta>%d\n",numerolinee, (int)(y*dStep) ,(int)(x*thetaStep) + 179));
        }
	numerolinee++;
      }//fine if massimi locali
    }
  }
  free(segment);
  free(edgeArray);
  //disalloco la memoria per ogni riga dell'array di accumulazione
  for(int t=0;t<=dInterval;t++) free(a[t]);
  free(a);
/*
  int* pcacca=(int*) malloc(3*sizeof(int*));
  if (pcacca == NULL) while(1) OSYSDEBUG(("4")); //exit (2);
  //pcacca[0] = 1;//linex;
  // pcacca[1] = 1;//liney;
  // pcacca[2] = 1;//a[liney][linex];
  //while(1) int* a = (int*) calloc(3000,sizeof(int));
  
  //da cancellare 
  pcacca[0] = (int)(linex*thetaStep) + 179;//theta da 0 a 359
  pcacca[1] = liney;//rho
  pcacca[2] = numerolinee;//numPuntiUtili;
*/

 return pcacca;
 
}

void EventMgr::GetPanTiltAngle(longword frameNum,double* pan, double* tilt2, double* tilt){
  list<RCRegion*>::iterator iter = sensorRegions.begin();
  list<RCRegion*>::iterator last = sensorRegions.end();
  OSensorFrameVectorData* sv;
  OSensorFrameInfo* info;
  OSensorFrameData* data;
  while (iter != last) 
    {
      sv = (OSensorFrameVectorData*)(*iter)->Base();
      info = sv->GetInfo(sensoridx[PAN_INDEX]);
      longword fn = info->frameNumber;
      
      for (size_t i = 0; i < info->numFrames; i++) 
	{
	  if (fn == frameNum) 
	    {
	      data = sv->GetData(sensoridx[PAN_INDEX]);
	      *pan = degrees((double)data->frame[i].value / 1000000.0);
	      
	      data = sv->GetData(sensoridx[TILT2_INDEX]);
	      *tilt2 = degrees((double)data->frame[i].value / 1000000.0);
	      
	      data = sv->GetData(sensoridx[TILT_INDEX]);
	      *tilt = degrees((double)data->frame[i].value / 1000000.0);
	      
	      return;
	    }
	  
	  fn++;
	  if (fn > oframeMAX_NUMBER) fn = 1;
	}
        
      ++iter;
    }

  //
  // If sensor data at frameNum is not found, 
  // return latest sensor data.
  //
  RCRegion* rgn = sensorRegions.back();
  sv = (OSensorFrameVectorData*)rgn->Base();
  info = sv->GetInfo(sensoridx[PAN_INDEX]);
  
  data = sv->GetData(sensoridx[PAN_INDEX]);
  *pan = degrees((double)data->frame[info->numFrames-1].value / 1000000.0);
  
  data = sv->GetData(sensoridx[TILT2_INDEX]);
  *tilt2 = degrees((double)data->frame[info->numFrames-1].value / 1000000.0); 
  
  data = sv->GetData(sensoridx[TILT_INDEX]);
  *tilt = degrees((double)data->frame[info->numFrames-1].value / 1000000.0);
}

void EventMgr::GetIrHeadDistance(longword frameNum, int* near, int* far){
  list<RCRegion*>::iterator iter = sensorRegions.begin();
  list<RCRegion*>::iterator last = sensorRegions.end();
  OSensorFrameVectorData* sv;
  OSensorFrameInfo* info;
  OSensorFrameData* data;
  while (iter != last) 
    {
      sv = (OSensorFrameVectorData*)(*iter)->Base();
      info = sv->GetInfo(sensoridx[HEAD_IRSENSOR_NEAR]);
      longword fn = info->frameNumber;
      
      for (size_t i = 0; i < info->numFrames; i++) 
	{
	  if (fn == frameNum) 
	    {
	      data = sv->GetData(sensoridx[HEAD_IRSENSOR_NEAR]);
	      *near=(int)data->frame[i].value;
	      data = sv->GetData(sensoridx[HEAD_IRSENSOR_FAR]);
	      *far=(int)data->frame[i].value;
	      
	      return;
	    }
	  
	  fn++;
	  if (fn > oframeMAX_NUMBER) fn = 1;
	}
        
      ++iter;
    }

  //
  // If sensor data at frameNum is not found, 
  // return latest sensor data.
  //
  RCRegion* rgn = sensorRegions.back();
  sv = (OSensorFrameVectorData*)rgn->Base();
  
  info = sv->GetInfo(sensoridx[HEAD_IRSENSOR_NEAR]);

  data = sv->GetData(sensoridx[HEAD_IRSENSOR_NEAR]);
  *near=(int)data->frame[info->numFrames-1].value;
  data = sv->GetData(sensoridx[HEAD_IRSENSOR_FAR]);
  *far=(int)data->frame[info->numFrames-1].value;
}

void EventMgr::OpenPrimitives(){
    OStatus result;
    for (size_t i = 0; i < NUM_SENSORS; i++) 
      {
        result = OPENR::OpenPrimitive(SENSOR_LOCATOR[i], &jointID[i]);
        if (result != oSUCCESS)  OSYSLOG1((osyslogERROR, "%s : %s %d","Occipital::OpenPrimitives()","OPENR::OpenPrimitive() FAILED", result));
      }
    
    result = OPENR::OpenPrimitive(FBK_LOCATOR, &fbkID);
    if (result != oSUCCESS) OSYSLOG1((osyslogERROR, "%s : %s %d","Occipital::OpenPrimitives()","OPENR::OpenPrimitive() FAILED", result));    
}


void EventMgr::SetCameraParameter(){
  //OPrimitiveControl_CameraParam shutter(ocamparamSHUTTER_MID);
  OPrimitiveControl_CameraParam shutter(ocamparamSHUTTER_FAST);
  OPENR::ControlPrimitive(fbkID, oprmreqCAM_SET_SHUTTER_SPEED, &shutter, sizeof(shutter ) , 0 , 0);
  OPrimitiveControl_CameraParam gain(ocamparamGAIN_MID);
  OPENR::ControlPrimitive(fbkID, oprmreqCAM_SET_GAIN, &gain , sizeof(gain), 0,0);
  OPrimitiveControl_CameraParam wb(ocamparamWB_INDOOR_MODE);
  OPENR::ControlPrimitive (fbkID,oprmreqCAM_SET_WHITE_BALANCE, &wb, sizeof(wb),0,0);
  // Bilanciamento del bianco automatico
  OPENR::ControlPrimitive (fbkID, oprmreqCAM_AWB_OFF, 0, 0, 0, 0);
  // Bilanciamento esposizione automatico
  OPENR::ControlPrimitive (fbkID, oprmreqCAM_AE_OFF, 0, 0, 0, 0);
 }

void EventMgr::InitSensorIndex(OSensorFrameVectorData* sensorVec){

  for (size_t i = 0; i < NUM_SENSORS; i++) 
    for (size_t j = 0; j < sensorVec->vectorInfo.numData; j++) 
      {
	OSensorFrameInfo* info = sensorVec->GetInfo(j);
	if (info->primitiveID == jointID[i]) 
	  {
	    sensoridx[i] = j;
	    OSYSDEBUG(("[%2d] %s\n", sensoridx[i], SENSOR_LOCATOR[i]));
	    break;
	  }
      }
}


/*DoStop: arresta Telepati*/
OStatus EventMgr::DoStop(const OSystemEvent& event){  OSYSDEBUG(("EventMgr::DoStop()\n"));  DISABLE_ALL_SUBJECT;  DEASSERT_READY_TO_ALL_OBSERVER;  OStatus st = OPENR::SetMotorPower(opowerOFF);   return oSUCCESS;}  //DoStop() END


/*DoDestroy: libera la memoria occupata da Telepati*/
OStatus EventMgr::DoDestroy(const OSystemEvent& event){  OSYSDEBUG(("EventMgr::DoDestroy\()\n"));  DELETE_ALL_SUBJECT_AND_OBSERVER;  return oSUCCESS;}  //DoDestroy() END

void
EventMgr::SaveData(int serialNumber, OFbkImageVectorData* imageVec)
{
    char name[128];
    BMP bmp;

    sprintf(name, "/ms/open-r/mw/data/p/RGBH%04d.BMP", serialNumber);///MS/OPEN-R/MW/DATA/P/RGBH%04d.BMP", serialNumber);
    OSYSPRINT(("writing %s ...\n", name));
    bmp.SaveYCrCb2RGB(name, imageVec, ofbkimageLAYER_H);
  /*
    sprintf(name, "/MS/OPEN-R/MW/DATA/P/LAYH%04d.RAW", serialNumber);
    OSYSPRINT(("writing %s ...\n", name));
    SaveRawData(name, imageVec, ofbkimageLAYER_H);
  
    sprintf(name, "/MS/OPEN-R/MW/DATA/P/LAYM%04d.RAW", serialNumber);
    OSYSPRINT(("writing %s ...\n", name));
    SaveRawData(name, imageVec, ofbkimageLAYER_M);

    sprintf(name, "/MS/OPEN-R/MW/DATA/P/LAYL%04d.RAW", serialNumber);
    OSYSPRINT(("writing %s ...\n", name));
    SaveRawData(name, imageVec, ofbkimageLAYER_L);
    */
    OSYSPRINT(("done.\n"));
}
void
EventMgr::SaveRawData(char* path,
                           OFbkImageVectorData* imageVec, OFbkImageLayer layer)
{
    OFbkImageInfo* info = imageVec->GetInfo(layer);
    byte*          data = imageVec->GetData(layer);

    size_t size;
    if (layer == ofbkimageLAYER_C) {

        size = info->width * info->height;

    } else { // ofbkimageLAYER_H or ofbkimageLAYER_M or ofbkimageLAYER_L

        if (info->type == odataFBK_YCrCb) {
            size = 3 * info->width * info->height;
        } else if (info->type == odataFBK_YCrCb_HPF) {
            size = 6 * info->width * info->height;
        }

    }

    FILE* fp = fopen(path, "w");
    if (fp == 0) {
        OSYSLOG1((osyslogERROR, "can't open %s", path));
        return;
    }
    fwrite(data, 1, size, fp);
    fclose(fp);
}






//da mettere in notify image per aggiungere la ricerca delle linee



/*
  //trovo gli edge
  const unsigned char* edgeImage = NULL;
  edgeImage = edge->getMagnitude(static_cast<unsigned char*>(data));
  if(edgeImage != NULL) ;//OSYSDEBUG(("**************************************** edge trovato con successo!!!  **********************************************************\n"));
  else OSYSDEBUG(("****************************************  edge NON trovato con successo!!!  **********************************************************\n"));
  
  unsigned int numpixellinee = seg->getNumberOfRecognizedPixel(AISAiboYCrCbColorSeg::l0);

  // calcolo il numero dei pixel trovati
  int** hough=NULL;
  //calcolo angoli testa
  double pan=0, tilt=0, tilt2=0;
  //OFbkImageVectorData* imageVecPam = reinterpret_cast<OFbkImageVectorData*>(const_cast<void*>(event.Data(0)));
  OFbkImageInfo* info = imageVec->GetInfo(ofbkimageLAYER_C);
  GetPanTiltAngle(info->frameNumber, &pan, &tilt2, &tilt);
  //OSYSDEBUG(("GetPanTiltAngle -> %f, %f, %f\n", pan, tilt, tilt2));
  //Trova una linea del campo
  if(numpixellinee > 40 && edgeImage != NULL && ptr != NULL){ //se ho trovato + di 40 punti bianchi */
   //da rimettere // hough = trovoLineaPrincipaleHough(ptr,1,height, width, 8/* 20 soglia edge*/,40 /*thetaInterval*/,100/*dInterval*/,edgeImage);
  /*
    if(hough!=NULL) OSYSDEBUG(("numero linee trovate: %d\n",hough[2]));//"********************** linea trovata: THETA=>%d,RHO=>%d, punti sulla retta=>%d \n",hough[0],hough[1],hough[2]));//numpixellinee));
    //else  OSYSDEBUG(("******hough null **prevBallDista******\n"));
  }else  OSYSDEBUG(("******  pochi pixel bianchi ********\n"));
/*
  //for(int i=0;i<numLineeCampo;i++) {
  //  if(treLineeCampo[i][0] < 361){
  //    
  //  }
  //}
*/
  //OSYSDEBUG(("EventMgr::NotifyImage ricevuta un'immagine\n"));
  /*
  if((hough[0] >= (lineeCampo[numLineeCampo][1] + 10) % 360 || hough[0] <= (lineeCampo[numLineeCampo][1] - 10) % 360 )){ //se hai trovato (sxo) la stessa linea di prima
   if(numLineeCampo <= 3 and numImmagini > 4) {//se nn sn ancora state trovate 3 linee e abbiamo trovato 4 immagini della stessa retta.
      numLineeCampo++;
      lineeCampo[numLineeCampo][0] = hough[0];
      lineeCampo[numLineeCampo][1] = hough[1];
      numImmagini = 0;
   }
   numImmagini = 1;
  }else { //se e' la stessa linea di prima
    numImmagini++;
  }
  *//*
  if(hough!=NULL)  free(hough); 
  
  //OSYSDEBUG(("Pan -> %f, numImagini -> %d tilt -> %f\n", pan, numImmagini,tilt));
  if(numImmagini>-1 && numImmagini <10 && (pan >80 ||(pan>35 && pan <45) ||(pan>65 && pan <75)||(pan>-10 && pan <10) ) && tilt > 5){SaveData(numImmagini,imageVec);numImmagini++;}
  */
