/* LICENSE:
  =========================================================================
    CMPack'04 Source Code Release for OPEN-R SDK 1.1.5-r2 for ERS7
    Copyright (C) 2004 Multirobot Lab [Project Head: Manuela Veloso]
    School of Computer Science, Carnegie Mellon University
    All rights reserved.
  ========================================================================= */

#ifndef WalkParam_h
#define WalkParam_h
#include "../headers/Geometry.h"

namespace Motion {

struct VelParam{
  double max_dx;
  double max_dy;
  double max_da;
};

struct LegParam{
  vector3d neutral;
  vector3d lift_vel,down_vel;
  double lift_time,down_time;
};

struct WalkParam{
  LegParam leg[4];
  VelParam max_vel;
  double body_height;
  double body_angle;
  double hop;  // sinusoidal hop amplitude
  double sway; // sinusoidal sway in y direction
  long period;
  long reserved;
  double front_height, back_height;
};

}

#endif
