#ifndef RGEN_H_DEFINED
#define RGEN_H_DEFINED

#include <queue>
#include <OPENR/OObject.h>
#include <OPENR/OSubject.h>
#include <OPENR/OObserver.h>
#include <OPENR/RCRegion.h>
#include "def.h"
#include "../headers/Geometry.h"
#include "../Motion/MotionInterface.h"






class RGen : public OObject {

public:
  RGen();
  virtual ~RGen() {};

  OSubject*    subject[numOfSubject];
  OObserver*   observer[numOfObserver];
   
  virtual OStatus DoInit   (const OSystemEvent& event);
  virtual OStatus DoStart  (const OSystemEvent& event);
  virtual OStatus DoStop   (const OSystemEvent& event);
  virtual OStatus DoDestroy(const OSystemEvent& event);
  void NotifyRLib(const ONotifyEvent& event);
  void NotifyEventMgr(const ONotifyEvent& event);
  void Ready(const OReadyEvent& event);
  void TimerEnd(void* msg);


  void DecideAction(int state);
  int nextAction;
private:
  std::queue<int> codaComandi;
  int ActionVector[10];
  int range;
  
};


#endif
