#include "RLib.h"
#include <OPENR/OSyslog.h>
#include <OPENR/core_macro.h>
#include <OPENR/OPENRAPI.h>
#include "../utils/utils.h"
#include "../EventMgr/EventMgr.h"
	
RLib::RLib(){
  currentRLibInfo = NULL;
}


OStatus RLib::DoInit(const OSystemEvent& event){
  OSYSDEBUG(("RLib::DoInit()\n"));
  
  //inizializzo il nextCmd a CERCA 
  //CreateCommand(CERCA);


  NEW_ALL_SUBJECT_AND_OBSERVER;
  REGISTER_ALL_ENTRY;
  SET_ALL_READY_AND_NOTIFY_ENTRY;
  
  return oSUCCESS;
}


/*DoStart: fa partire Telepati*/
OStatus RLib::DoStart(const OSystemEvent& event){
  OSYSDEBUG(("RLib::DoStart()\n"));
  
  ENABLE_ALL_SUBJECT;
  ASSERT_READY_TO_ALL_OBSERVER;  
  
  int dummy=0;
  /*
  EventID sincroEvent = EventID();
  RelativeTime period(2, 0);
  TimeEventInfoWithRelativeTime timeInfo(TimeEventInfo::Periodic, period);
  sError error=SetTimeEvent(&timeInfo,myOID_,Extra_Entry[entryTimerEnd],&dummy,sizeof(dummy),&sincroEvent);
  if(error!=sSUCCESS) 
    OSYSLOG1((osyslogERROR, "::DoStart() : ERROR: Sincronization Timer not started\n"));
  
  */
  return oSUCCESS;
}  //DoStart() END


/*DoStop: arresta Telepati*/
OStatus RLib::DoStop(const OSystemEvent& event){
  OSYSDEBUG(("RLib::DoStop()\n"));
  
  DISABLE_ALL_SUBJECT;
  DEASSERT_READY_TO_ALL_OBSERVER;
  //OStatus st = OPENR::SetMotorPower(opowerOFF); 
  
  return oSUCCESS;
}  //DoStop() END


/*DoDestroy: libera la memoria occupata da Telepati*/
OStatus RLib::DoDestroy(const OSystemEvent& event){
  OSYSDEBUG(("RLib::DoDestroy\()\n"));
  DELETE_ALL_SUBJECT_AND_OBSERVER;
  
  return oSUCCESS;
}  //DoDestroy() END


/*
void RLib::TimerEnd(void* msg){
  if(!codaComandi.empty()){
    PRN(("RLib: Passo il comando allo skeduler: %d %d\n",codaComandi.front().getcmd().motion_cmd,codaComandi.front().getpriority()));
    subject[sbjIndMov]->SetData(&(codaComandi.front()),sizeof(MovementIndication));
    subject[sbjIndMov]->NotifyObservers();
    codaComandi.pop();
  }
  
}
*/


//ricevo un comando da RGen
void RLib::Notify(const ONotifyEvent& event){
  //prendo il comando
  int *i = (int *)event.Data(0);
  //creo 1 comando in formato Motion command e lo invio
  RLib::CreateCommand(*i);
  //PRN(("RLib: comando ricevuto -> %d\n",*i));
  if(!codaComandi.empty()){
    //PRN(("RLib: Passo il comando allo skeduler: head_cmd -> %d \n",codaComandi.front().getcmd().head_cmd,codaComandi.front().getpriority()));
    subject[sbjIndMov]->SetData(&(codaComandi.front()),sizeof(MovementIndication));
    subject[sbjIndMov]->NotifyObservers();
    codaComandi.pop();
  }
 observer[event.ObsIndex()]->AssertReady();
}

void RLib::GetRLibInfoNotify(const ONotifyEvent& event){
  currentRLibInfo = (RLibInfo*)event.Data(0);
  //printf("RLib: Aggiornata posizione collo -> pan= %f, tilt= %f, tilt2= %f centroide x->%d y->%d\n",currentRLibInfo->neckAngle.pan, currentRLibInfo->neckAngle.tilt,currentRLibInfo->neckAngle.tilt2,currentRLibInfo->centroide.x,currentRLibInfo->centroide.y);
  observer[event.ObsIndex()]->AssertReady();
}


void RLib::Ready(const OReadyEvent& event){
  //OSYSDEBUG(("RLib:: ricevuto Assert Ready\n"));
}

void RLib::CreateCommand(int num_command){
  Motion::MotionCommand cmd;
  MovementIndication indy;
  switch(num_command){
  case 0:
    PRN(("RLib: Eseguo STOP\n"));
    cmd.motion_cmd=0;
    indy.command = cmd;
    indy.priority = 0;
    indy.time = 1;
    break;
  
  case 1:
    //PRN(("RLib: Eseguo il comando CERCO PALLA\n"));
    cmd.motion_cmd=Motion::MOTION_STAND_NEUTRAL;//MOTION_STAND_CROUCH;//  //MOTION_STAND_LEFT;//
    cmd.head_cmd=Motion::HEAD_SCAN_OBSTACLES;//HEAD_SCAN_BALL;//HEAD_SCAN_OBSTACLES;//
    //cmd.tail_cmd=Motion::TAIL_NO_CMD;
    cmd.mouth=0; 
    cmd.setFaceLEDs(0,0,Motion::MODE_B);
    indy.command = cmd;
    indy.priority = 40;
    indy.time = 1;
    break;
  
  case 2:
    //PRN(("RLib: Eseguo il comando *SEGUI LA PALLA CON LA TESTA*\n"));
    //cmd.motion_cmd=Motion:: MOTION_STAND_NEUTRAL; // MOTION_STAND_LEFT;//MOTION_STAND_CROUCH;
    cmd.head_cmd=Motion::HEAD_ANGLES;
    //cmd.bound_mode;       
    //cmd.vx=0;
    //cmd.vy=0;
    //cmd.va=0;
    //cmd.head_lookat=vector3d(0,0,0);  
    cmd.head_tilt_offset=0;
    //calcolo lo spostamento, dati il centroide e la posizione del collo
    //if (currentRLibInfo != NULL) printf("RLib: xcentroide-> %d, ycentroide-> %d\n",currentRLibInfo->centroide.x,currentRLibInfo->centroide.y);
    // printf("scostamenti dal centro x> %f,y>%f \n",(double)currentRLibInfo->centroide.x - CENTRO_X,(double)currentRLibInfo->centroide.y - CENTRO_Y);
    if ((currentRLibInfo != NULL)){// && (abs((double)currentRLibInfo->centroide.x - CENTRO_X) > 2 || abs((double)currentRLibInfo->centroide.y - CENTRO_Y) > 2)){
      cmd.head_pan = RAD((GRADI_PER_PIXEL_X * (CENTRO_X - (double)currentRLibInfo->centroide.x)) + currentRLibInfo->neckAngle.pan);
      cmd.head_tilt2 = RAD((GRADI_PER_PIXEL_Y * (CENTRO_Y - (double)currentRLibInfo->centroide.y)) + currentRLibInfo->neckAngle.tilt2);
      //printf("HEAD MOVE ************\n");
      
      //cmd.head_pan = RAD(currentRLibInfo->neckAngle.pan + atan(RAD((CENTRO_X - (double)currentRLibInfo->centroide.x)/FOCALE_PX)));
      //cmd.head_tilt2 =RAD(currentRLibInfo->neckAngle.tilt2 + atan(RAD((CENTRO_Y - (double)currentRLibInfo->centroide.y)/FOCALE_PX)));
      

      // printf("current pan>%f,tilt2>%f\n",currentRLibInfo->neckAngle.pan,currentRLibInfo->neckAngle.tilt2);
      //printf("angolo palla x>%f,y>%f\n",atan(RAD((CENTRO_X - (double)currentRLibInfo->centroide.x)/FOCALE_PX)),atan(RAD((CENTRO_Y - (double)currentRLibInfo->centroide.y)/FOCALE_PX)));
      //printf("RLib: Spostament pan> %f\n",currentRLibInfo->neckAngle.pan + atan(RAD((CENTRO_X - (double)currentRLibInfo->centroide.x)/FOCALE_PX)));
      //printf("RLib: Spostament tilt2> %f\n",currentRLibInfo->neckAngle.tilt2 + atan(RAD((CENTRO_Y - (double)currentRLibInfo->centroide.y)/FOCALE_PX)));



      //printf("RLib: Motion pan ->%f, currentRLibInfo->centroide.x ->  **** %d **** currentRLibInfo->neckAngle.pan -> %f\n",((((int)CENTRO_X - (int)currentRLibInfo->centroide.x)*GRADI_PER_PIXEL_X)+currentRLibInfo->neckAngle.pan),currentRLibInfo->centroide.x,currentRLibInfo->neckAngle.pan);
      //printf("RLib: Motion tilt2 ->%f, currentRLibInfo->centroide.y ->  **** %d **** currentRLibInfo->neckAngle.pan -> %f\n",((((int)CENTRO_Y - (int)currentRLibInfo->centroide.y)*GRADI_PER_PIXEL_Y)+currentRLibInfo->neckAngle.tilt2),currentRLibInfo->centroide.y,currentRLibInfo->neckAngle.tilt2);
      //}else if (currentRLibInfo != NULL){
      //cmd.head_tilt= RAD(currentRLibInfo->neckAngle.tilt);
      //cmd.head_pan=RAD(currentRLibInfo->neckAngle.pan);
      //cmd.head_tilt2=RAD(currentRLibInfo->neckAngle.tilt2);
    }
    cmd.head_roll=0;
    cmd.mouth=0;
    cmd.setFaceLEDs(0,0,Motion::MODE_A);
    indy.command = cmd;
    indy.priority = 1000;
    indy.time = 1;
    break;

  case 3:
    //PRN(("RLib: Eseguo il comando *MOTION_BLOCK_GOALIE_L*\n"));
    cmd.motion_cmd=Motion::MOTION_BLOCK_GOALIE_L;    
    //cmd.head_cmd=Motion::HEAD_NO_CMD;
    //cmd.tail_cmd=Motion::TAIL_FOLLOW;
    //cmd.bound_mode;
    //cmd.vx=0;
    //cmd.vy=0;
    //cmd.va=0;      
    //cmd.head_lookat=vector3d(0,0,0);
    //cmd.mouth=0;          
    cmd.setFaceLEDs(0,0,Motion::MODE_A);
    indy.command = cmd;
    indy.priority = 3;
    indy.time = 1;
    break;

case 4:
  //PRN(("RLib: Eseguo il comando *MOTION_BLOCK_GOALIE_C*\n"));
    cmd.motion_cmd=Motion::MOTION_BLOCK_GOALIE_C;//MOTION_BLOCK_SUPP;//
    //cmd.head_cmd=Motion::MOTION_BLOCK_GOALIE_C;
    //cmd.tail_cmd=Motion::TAIL_FOLLOW;
    //cmd.head_cmd=Motion::HEAD_NO_CMD;
    cmd.setFaceLEDs(0,0,Motion::MODE_B);
    indy.command = cmd;
    indy.priority = 3;
    indy.time = 3;
    break;

case 5:
  //PRN(("RLib: Eseguo il comando *MOTION_BLOCK_GOALIE_R*\n"));
    cmd.motion_cmd=Motion::MOTION_BLOCK_GOALIE_R;//MOTION_BLOCK_GOALIE_R;       
    //cmd.head_cmd=Motion::MOTION_BLOCK_GOALIE_R;
    //cmd.tail_cmd=Motion::TAIL_FOLLOW;
    //cmd.head_cmd=Motion::HEAD_NO_CMD;
    cmd.setFaceLEDs(0,0,Motion::MODE_A);
    indy.command = cmd;
    indy.priority = 3;
    indy.time = 3;
    break;

case 6:
    PRN(("RLib: Eseguo il comando TRICK STAND_CROUCH\n"));
    cmd.motion_cmd=Motion::MOTION_STAND_CROUCH; //MOTION_STAND_NEUTRAL;  
    cmd.head_cmd=Motion::HEAD_SCAN_OBSTACLES;//HEAD_SCAN_BALL;
    //cmd.tail_cmd=Motion::TAIL_NO_CMD;
    //cmd.mouth=0; 
    cmd.setFaceLEDs(0,0,Motion::MODE_B);
    indy.command = cmd;
    indy.priority = 40;
    indy.time = 1;
    break;
   
case 7:
  //PRN(("RLib: Eseguo il comando *SEGUI LA PALLA CON LA TESTA e ALZATI*\n"));
  cmd.motion_cmd=Motion::MOTION_STAND_CROUCH;//MOTION_STAND_NEUTRAL; // MOTION_STAND_LEFT
    cmd.head_cmd=Motion::HEAD_ANGLES;
    //cmd.bound_mode;       
    //cmd.vx=0;
    //cmd.vy=0;
    //cmd.va=0;
    //cmd.head_lookat=vector3d(0,0,0);  
    cmd.head_tilt_offset=0;
    //calcolo lo spostamento, dati il centroide e la posizione del collo
    //if (currentRLibInfo != NULL) printf("RLib: xcentroide-> %d, ycentroide-> %d\n",currentRLibInfo->centroide.x,currentRLibInfo->centroide.y);
    if (currentRLibInfo != NULL ){ // && abs((int)currentRLibInfo->centroide.x - (int)CENTRO_X) > 2 && abs((int)currentRLibInfo->centroide.y - (int)CENTRO_Y) > 2){
      //cmd.head_tilt=RAD(currentRLibInfo->neckAngle.tilt); 
      cmd.head_pan=RAD((((int)CENTRO_X - (int)currentRLibInfo->centroide.x)*GRADI_PER_PIXEL_X) + currentRLibInfo->neckAngle.pan);
      cmd.head_tilt2=RAD((((int)CENTRO_Y - (int)currentRLibInfo->centroide.y)*GRADI_PER_PIXEL_Y) + currentRLibInfo->neckAngle.tilt2);
      //cmd.head_tilt2=RAD(currentRLibInfo->neckAngle.tilt2);
      //printf("RLib: Spostament pan> %f\n",(((int)CENTRO_X - (int)currentRLibInfo->centroide.x)*GRADI_PER_PIXEL_X));
      //printf("RLib: Spostament tilt2> %f\n",(((int)currentRLibInfo->centroide.y - (int)CENTRO_Y)*GRADI_PER_PIXEL_Y)+currentRLibInfo->neckAngle.tilt2);
      //printf("RLib: Motion pan ->%f, currentRLibInfo->centroide.x ->  **** %d **** currentRLibInfo->neckAngle.pan -> %f\n",((((int)CENTRO_X - (int)currentRLibInfo->centroide.x)*GRADI_PER_PIXEL_X)+currentRLibInfo->neckAngle.pan),currentRLibInfo->centroide.x,currentRLibInfo->neckAngle.pan);
      //printf("RLib: Motion tilt2 ->%f, currentRLibInfo->centroide.y ->  **** %d **** currentRLibInfo->neckAngle.pan -> %f\n",((((int)CENTRO_Y - (int)currentRLibInfo->centroide.y)*GRADI_PER_PIXEL_Y)+currentRLibInfo->neckAngle.tilt2),currentRLibInfo->centroide.y,currentRLibInfo->neckAngle.tilt2);
    }else if (currentRLibInfo != NULL){
      //cmd.head_tilt= RAD(currentRLibInfo->neckAngle.tilt);
      //cmd.head_pan=RAD(currentRLibInfo->neckAngle.pan);
      //cmd.head_tilt2=RAD(currentRLibInfo->neckAngle.tilt2);
    }
    cmd.setFaceLEDs(0,0,Motion::MODE_A);
    indy.command = cmd;
    indy.priority = 1000;
    indy.time = 1;
    break;  
   
  } 
  //PRN(("RLib::Invio il comando ---->  motion_command = %d,head_cmd = %d, pan = %f --- \n",cmd.motion_cmd,cmd.head_cmd, cmd.head_pan));
  if(num_command == 1){codaComandi.push(indy);}// printf("RLib: manda comando CERCA PALLA\n");}
  else if (num_command == 2 && currentRLibInfo != NULL)  codaComandi.push(indy);
       else codaComandi.push(indy);
  //if (currentRLibInfo == NULL) printf("RLib: niente currentRLibInfo!!!! ******** \n");
}

