#ifndef RLIB_H_DEFINED
#define RLIB_H_DEFINED
#include <OPENR/OObject.h>
#include <OPENR/OSubject.h>
#include <OPENR/OObserver.h>
#include <OPENR/RCRegion.h>
#include "def.h"
#include <queue>
#include "../headers/Geometry.h"
#include "../Motion/MotionInterface.h"
#include "../utils/utils.h"

using namespace std;


class MovementIndication{
    public:
    int time;
    int priority;
    Motion::MotionCommand command;
	
	Motion::MotionCommand getcmd(){
		return command;
		}
	int gettime(){
		return time;
		}
	int getpriority(){
		return priority;
		}
    };


class RLib : public OObject {
public:
	
  RLib();
  virtual ~RLib() {};

  OSubject*    subject[numOfSubject];
  OObserver*   observer[numOfObserver];
   
  virtual OStatus DoInit   (const OSystemEvent& event);
  virtual OStatus DoStart  (const OSystemEvent& event);
  virtual OStatus DoStop   (const OSystemEvent& event);
  virtual OStatus DoDestroy(const OSystemEvent& event);
  void Notify(const ONotifyEvent& event);
  void GetRLibInfoNotify(const ONotifyEvent& event);
  void Ready(const OReadyEvent& event);
  void CreateCommand(int num_command);
  void TimerEnd(void* msg);

private:
  queue<MovementIndication> codaComandi;
  MovementIndication nextCmd;
  RLibInfo* currentRLibInfo;
};

#endif
