#include "SLCtrl.h"
#include <OPENR/OSyslog.h>
#include <OPENR/core_macro.h>
#include <OPENR/OPENRAPI.h>
#include "entry.h"
#include "../Motion/MotionInterface.h"
#include "../utils/utils.h"

SLCtrl::SLCtrl(){
  Motion::MotionCommand cmd;
  MovementIndication indy;

  cmd.motion_cmd=Motion::MOTION_GOAL_HAPPY2;       
  cmd.head_cmd=Motion::HEAD_ANGLES;
  cmd.tail_cmd=Motion::TAIL_FOLLOW;
  cmd.bound_mode;       
  cmd.vx=150;
  cmd.vy=0;
  cmd.va=0;      
  cmd.head_lookat=vector3d(30,30,30);  
  cmd.head_tilt_offset=0;  
  cmd.head_tilt=-20.0; 
  cmd.head_pan=0;  
  cmd.head_roll=0; 
  cmd.head_tilt2=0; 
  cmd.tail_pan=60;       
  cmd.tail_tilt=0;   
  cmd.mouth=100;          
  cmd.sound_cmd=Motion::SOUND_FILE;
  cmd.sound_file=Motion::SOUND_FILE_RECTANGLE;
  cmd.sound_file=Motion::SOUND_FILE_TADA;

  cmd.setFaceLEDs(0,0,Motion::MODE_A);
  
  indy.command = cmd;
  indy.priority = 12;
  indy.time = 3;

  codaComandi.push(indy);


}

OStatus SLCtrl::DoInit(const OSystemEvent& event){
  OSYSDEBUG(("SLCtrl::DoInit()\n"));
  
  NEW_ALL_SUBJECT_AND_OBSERVER;
  REGISTER_ALL_ENTRY;
  SET_ALL_READY_AND_NOTIFY_ENTRY;

  return oSUCCESS;
}


/*DoStart: fa partire Telepati*/
OStatus SLCtrl::DoStart(const OSystemEvent& event){
  OSYSDEBUG(("SLCtrl::DoStart()\n"));

  ENABLE_ALL_SUBJECT;
  ASSERT_READY_TO_ALL_OBSERVER;

  OStatus st = OPENR::SetMotorPower(opowerON);   

  int dummy=0;
  //  EventID sincroEvent = EventID();
  //RelativeTime period(25, 0);
  //TimeEventInfoWithRelativeTime timeInfo(TimeEventInfo::Periodic, period);
  //sError error=SetTimeEvent(&timeInfo,myOID_,Extra_Entry[entryTimerEnd],&dummy,sizeof(dummy),&sincroEvent);
  //if(error!=sSUCCESS) 
  //OSYSLOG1((osyslogERROR, "::DoStart() : ERROR: Sincronization Timer not started\n"));
  
  
  return oSUCCESS;
}  //DoStart() END


/*DoStop: arresta Telepati*/
OStatus SLCtrl::DoStop(const OSystemEvent& event){
  OSYSDEBUG(("SLCtrl::DoStop()\n"));

  DISABLE_ALL_SUBJECT;
  DEASSERT_READY_TO_ALL_OBSERVER;
  OStatus st = OPENR::SetMotorPower(opowerOFF); 

  return oSUCCESS;
}  //DoStop() END



/*DoDestroy: libera la memoria occupata da Telepati*/
OStatus SLCtrl::DoDestroy(const OSystemEvent& event){
  OSYSDEBUG(("SLCtrl::DoDestroy\()\n"));

  DELETE_ALL_SUBJECT_AND_OBSERVER;

  return oSUCCESS;
}  //DoDestroy() END
/*
void SLCtrl::TimerEnd(void* msg){
  if(!codaComandi.empty())
    {
      PRN(("SLCtrl :: la legge sociale vi colpir! > %d\n", codaComandi.front().getpriority()));
      subject[sbjSocialAction]->SetData(&(codaComandi.front()),sizeof(MovementIndication));
      subject[sbjSocialAction]->NotifyObservers();
      //per ora ho un solo comando percui non lo poppo...
      //codaComandi.pop();
      
    }
}
*/
void SLCtrl::Notify(const ONotifyEvent& event){
  OSYSDEBUG(("SLCtrl:: ricevuto un notify\n"));
}

void SLCtrl::Ready(const OReadyEvent& event){
  OSYSDEBUG(("SLCtrl:: ricevuto Assert Ready\n"));
}
