#include "SWMgr.h"
#include <OPENR/OSyslog.h>
#include <OPENR/core_macro.h>
#include <OPENR/OPENRAPI.h>
#include "entry.h"
#include "../Motion/MotionInterface.h"

SWMgr::SWMgr(){
  //niente qui per ora

}

OStatus SWMgr::DoInit(const OSystemEvent& event){
  OSYSDEBUG(("SWMgr::DoInit()\n"));
  
  NEW_ALL_SUBJECT_AND_OBSERVER;
  REGISTER_ALL_ENTRY;
  SET_ALL_READY_AND_NOTIFY_ENTRY;

  return oSUCCESS;
}


/*DoStart: fa partire Telepati*/
OStatus SWMgr::DoStart(const OSystemEvent& event){
  OSYSDEBUG(("SWMgr::DoStart()\n"));

  ENABLE_ALL_SUBJECT;
  ASSERT_READY_TO_ALL_OBSERVER;

  OStatus st = OPENR::SetMotorPower(opowerON);   

  int dummy=0;
  EventID sincroEvent = EventID();
  RelativeTime period(10, 0);
  TimeEventInfoWithRelativeTime timeInfo(TimeEventInfo::Periodic, period);
  sError error=SetTimeEvent(&timeInfo,myOID_,Extra_Entry[entryTimerEnd],&dummy,sizeof(dummy),&sincroEvent);
  if(error!=sSUCCESS) 
    OSYSLOG1((osyslogERROR, "::DoStart() : ERROR: Sincronization Timer not started\n"));
  
  
  return oSUCCESS;
}  //DoStart() END


/*DoStop: arresta Telepati*/
OStatus SWMgr::DoStop(const OSystemEvent& event){
  OSYSDEBUG(("SWMgr::DoStop()\n"));

  DISABLE_ALL_SUBJECT;
  DEASSERT_READY_TO_ALL_OBSERVER;
  //OStatus st = OPENR::SetMotorPower(opowerOFF); 

  return oSUCCESS;
}  //DoStop() END


/*DoDestroy: libera la memoria occupata da Telepati*/
OStatus SWMgr::DoDestroy(const OSystemEvent& event){
  OSYSDEBUG(("SWMgr::DoDestroy\()\n"));

  DELETE_ALL_SUBJECT_AND_OBSERVER;

  return oSUCCESS;
}  //DoDestroy() END

void SWMgr::TimerEnd(void* msg){
 //nemmeno qui
}

void SWMgr::Notify(const ONotifyEvent& event){
  OSYSDEBUG(("SWMgr:: ricevuto un notify\n"));
}

void SWMgr::Ready(const OReadyEvent& event){
  OSYSDEBUG(("SWMgr:: ricevuto Assert Ready\n"));
}
