#include "Sked.h"
#include "../RLib/RLib.h"
#include <OPENR/OSyslog.h>
#include <OPENR/core_macro.h>
#include <OPENR/OPENRAPI.h>
#include "entry.h"
#include "../Motion/MotionInterface.h"
#include "../utils/utils.h"

Sked::Sked(){
  useless_cmd.motion_cmd=NO_OPERATION;
  noMovement_cmq.motion_cmd=Motion::MOTION_STAND_NEUTRAL;  
  noMovement_cmq.head_cmd=Motion::HEAD_NO_CMD;
  noMovement_cmq.tail_cmd=Motion::TAIL_NO_CMD;
  noMovement_cmq.mouth=1;   
}

OStatus Sked::DoInit(const OSystemEvent& event){
  PRN(("Sked::DoInit()\n"));
  NEW_ALL_SUBJECT_AND_OBSERVER;
  REGISTER_ALL_ENTRY;
  SET_ALL_READY_AND_NOTIFY_ENTRY;
  
  vars=Init_para();
  codaPriority.push(0);
  codaComandi.push(useless_cmd);
  return oSUCCESS;
}


/*DoStart: fa partire*/ 
OStatus Sked::DoStart(const OSystemEvent& event){
  PRN(("Sked::DoStart()\n"));
  ENABLE_ALL_SUBJECT;
  ASSERT_READY_TO_ALL_OBSERVER;

  //OStatus st = OPENR::SetMotorPower(opowerON);   

  int dummy=0;
  EventID sincroEvent = EventID();
  RelativeTime period(1, 0);//in realt l'oggetto timer ha durata fissa percui il primo valore conta	//percui bisognerebbe metterlo ad un unità e poi inserire un NOP
  TimeEventInfoWithRelativeTime timeInfo(TimeEventInfo::Periodic, period);
  sError error=SetTimeEvent(&timeInfo,myOID_,Extra_Entry[entryTimerEnd],&dummy,sizeof(dummy),&sincroEvent);//verifica presenza di errori
  if(error!=sSUCCESS) OSYSLOG1((osyslogERROR, "Sked::DoStart() : ERROR: Sincronization Timer not started\n"));
  
  //PRN(("SKED::Timer %d",vars.sk_timeperiod));  
  
  return oSUCCESS;
}  //DoStart() END


void Sked::TimerEnd(void* msg){
  // if(!codaComandi.empty()) SendCommand();

}

/*
  if(!codaComandi.empty()){
    if(codaComandi.front().motion_cmd == NO_OPERATION){
      //devo solo eliminare il comando inutile dalla codaComandi
      codaComandi.pop();
      codaPriority.pop();
      // PRN(("Sked::motion_cmd == NO_OPERATIO quindi Poppo un NOP\n"));
    }
    else{
      //visto che questo non  un comando inutile lo invio
      SendCommand();
      // PRN(("Sked -> ************************* Mando un nuovo comando in EXEC -> %d\n",codaComandi.front().motion_cmd));
    }
  }else{ //se la coda e' vuola fagli smettere di fare qualsiasi cosa
    codaComandi.push(noMovement_cmq);
    codaPriority.push(1);
    //SendCommand();  <-- da rimettere
    // PRN(("Sked -> ************************* mando il comando \"nn fare niente\" EXEC xe' la codaComandi e' vuota.\n"));
  } 
}
*/
//notifica di motion sullo stato del comando ???
void Sked::Notify(const ONotifyEvent& event){
  //MovementIndication *indi = (MovementIndication *)event.Data(0);
  //  PRN(("Sked : NOTIFY indi->getpriority: %d\n",indi->getpriority()));
  //InsertCommand(indi);	
  PRN(("Sked:: motion notification *********************************************************"));
  observer[event.ObsIndex()]->AssertReady();
  
}

//comando inviato dal SLCtrl
void Sked::Notify2(const ONotifyEvent& event){
  //MovementIndication *indi = (MovementIndication *)event.Data(0);
  //PRN(("Sked : NOTIFY2(SLCtrl): %d\n",indi->getpriority()));
  //InsertCommand(indi); //evito che il SLCtrl mandi comandi
  observer[event.ObsIndex()]->AssertReady();
}

//inviato da RLib
void Sked::Notify3(const ONotifyEvent& event){
  MovementIndication *indi = (MovementIndication *)event.Data(0);
  //PRN(("Sked : NOTIFY3(RLib):%d\n",indi->getpriority()));
 

  //svuoto coda comandi, dopo dovro' inserire anche il fatto priorita'
  while(!codaComandi.empty()){
    codaComandi.pop();
    //PRN(("Sked:: codacomandi flushata\n"));
  }
  while(!codaPriority.empty()){
    codaPriority.pop();
    //PRN(("Sked:: priority flushata\n"));
  }

  if(indi->getcmd().motion_cmd != 0) InsertCommand(indi); //se il comando nn e' 0 quendi devo eseguire qlcosa
  else while(!codaComandi.empty()) codaComandi.pop(); //se nn devo fare eseguire neinte allo sked svuoto tt i comandi in coda
  /*  if(indi->getcmd().motion_cmd == Motion::HEAD_ANGLES)*/ SendCommand();

  observer[event.ObsIndex()]->AssertReady();
}

void Sked::Ready(const OReadyEvent& event){
  //PRN(("Sked:: ricevuto Assert Ready\n"));
}
void Sked::Ready2(const OReadyEvent& event){
  //PRN(("Sked:: ricevuto Assert Ready\n"));
}

void Sked::InsertCommand (MovementIndication *i){
  //PRN(("Sked:: prima del confronto i->getpriority: %d >> CP %d\n",i->getpriority(),codaPriority.front()));
  if(!codaPriority.empty() && codaPriority.front()<= i->getpriority()){
    //PRN(("Sked:: flusho perche' cp = %d mentre i = %d\n",codaPriority.front(),i->getpriority()));
    //il comando in coda ha priority piu' alta dell'ultimo arrivato
    //non devo fare assolutamente nulla... altrimenti  ------>
    //svuoto la coda
    while(!codaComandi.empty()){
      codaComandi.pop();
      //PRN(("Sked:: codacomandi flushata\n"));
    }
    while(!codaPriority.empty()){
      codaPriority.pop();
      //PRN(("Sked:: priority flushata\n"));
    }
    //ed inserisco il nuovo comando ... con un NOP ogni per ogni sec di exec
    codaComandi.push(i->getcmd());
    codaPriority.push(i->getpriority());
    for(int idx=0; idx<=i->gettime(); idx++){
      codaComandi.push(useless_cmd);
      codaPriority.push(i->getpriority());
    }
    //PRN(("Sked:: dopo flush inserisco: %d %d\n",codaComandi.front().motion_cmd,codaPriority.front()));
  }
  if(codaPriority.empty()){
    //PRN(("Sked: coda priorita' vuota quindi metto il comando nella coda\n"));
    codaComandi.push(i->getcmd());
    codaPriority.push(i->getpriority());
    for(int idx=0; idx<=i->gettime(); idx++){
      codaComandi.push(useless_cmd);
      codaPriority.push(i->getpriority());
    }
  }
}

void Sked::SendCommand (){
  //PRN(("Sked:: eseguo il comando!!!!! motion_command = %d,head_cmd = %d, pan = %f --- \n",codaComandi.front().motion_cmd,codaComandi.front().head_cmd, codaComandi.front().head_pan));
  //questo invia il comando a Motion
  //da scommentare
  subject[sbjMotionControl]->SetData(&(codaComandi.front()),sizeof(Motion::MotionCommand));
  subject[sbjMotionControl]->NotifyObservers();
  codaComandi.pop();
  codaPriority.pop();
}



/*DoStop: arresta */
OStatus Sked::DoStop(const OSystemEvent& event){ PRN(("Sked::DoStop()\n"));  DISABLE_ALL_SUBJECT; DEASSERT_READY_TO_ALL_OBSERVER;  OStatus st = OPENR::SetMotorPower(opowerOFF);   return oSUCCESS;}  //DoStop() END


/*DoDestroy: libera la memoria occupata*/
OStatus Sked::DoDestroy(const OSystemEvent& event){  PRN(("Sked::DoDestroy\()\n"));  DELETE_ALL_SUBJECT_AND_OBSERVER;  return oSUCCESS;}  //DoDestroy() END
