#ifndef SKED_H_DEFINED
#define SKED_H_DEFINED
#include <OPENR/OObject.h>
#include <OPENR/OSubject.h>
#include <OPENR/OObserver.h>
#include <OPENR/RCRegion.h>
#include "def.h"
#include <queue>
#include "../headers/Geometry.h"
#include "../Motion/MotionInterface.h"
#include "../RLib/RLib.h"
#include "../utils/utils.h"

using namespace std;

class Sked : public OObject {
public:
  Sked();
  virtual ~Sked() {};

  OSubject*    subject[numOfSubject];
  OObserver*   observer[numOfObserver];
   
  virtual OStatus DoInit   (const OSystemEvent& event);
  virtual OStatus DoStart  (const OSystemEvent& event);
  virtual OStatus DoStop   (const OSystemEvent& event);
  virtual OStatus DoDestroy(const OSystemEvent& event);
  void Notify(const ONotifyEvent& event);
  void Notify2(const ONotifyEvent& event);
  void Notify3(const ONotifyEvent& event);

  void Ready(const OReadyEvent& event);
  void Ready2(const OReadyEvent& event);
  void InsertCommand(MovementIndication *i);
  void SendCommand ();
	  
  void TimerEnd(void* msg);
private:
  queue<Motion::MotionCommand> codaComandi;
  queue<int> codaPriority;
  Motion::MotionCommand useless_cmd,noMovement_cmq;
  Init_para vars;
};

#endif
