/* LICENSE:
  =========================================================================
    CMPack'04 Source Code Release for OPEN-R SDK 1.1.5-r2 for ERS7
    Copyright (C) 2004 Multirobot Lab [Project Head: Manuela Veloso]
    School of Computer Science, Carnegie Mellon University
    All rights reserved.
  ========================================================================= */

#ifndef INCLDED_Config_h
#define INCLDED_Config_h

/*------------------------------------------------------------------
CLASS
  Config

DESCRIPTION
  Holder class for parameters for the system.
------------------------------------------------------------------*/
struct Config {
  struct SPOutConfig {
    int dumpVisionColorArea;
    int dumpVisionAvgColor;
    int dumpVisionRaw;
    int dumpVisionRLE;
    int dumpVisionObj;
    int dumpVisionRadialMap;
    int dumpModelObj;
    int dumpTracker;
    int dumpWMDebug;
    int dumpBehAct;
    int dumpLocalization;
    int dumpMoveUpdate;
    int dumpGSensor;
    int dumpFootSensor;
    int dumpDutyCycle;
    int dumpTeamMsgMgrObj;
    int dumpBehaviorNames;
    int dumpBehaviorTrace;
    bool dumpRate;
    bool dumpProfile;
  };

  SPOutConfig spoutConfig;

  void init();
  void config(const char *filename);
  void configSPOut(const char *filename);
};

extern Config config;

#endif
