#ifndef TIMEINFOPKG_H_DEF
#define TIMEINFOPKG_H_DEF

#include "TelepatiPkg.h"
#include <SystemTime.h>
#include <time.h>

using namespace std;

/**implementa il messaggio di sincronizzazione.  Viene spedito per
   sincronizzare gli orologi del ricevente, contiene il clock
   aggiornato.  Telepati  strutturato in modo da aggiornare l'ora
   contenuta in un TimeInfoPkg poco prima di spedirlo via
   rete.Struttura: e' composto dall'header standard e dal clock
   (sizeof(time_t))
*/
class TimeInfoPkg : public TelepatiPkg{
 public:
  /** Costruttore ordinario. @param a aibo di destinazione. @param time tempo da impostare. @param ack se richiede o meno l'Ack*/
  TimeInfoPkg(int a, const SystemTime& time, bool ack);
  /**Costruisce l'oggetto a partire dall'array restituito da
     getMsg(). @param ptr puntatore all'array di byte. @see
     getMsg()*/
  TimeInfoPkg(byte* ptr);

  /** Distruttore di Default.*/
  virtual ~TimeInfoPkg();

  /** Clonatore. Restituisce un clone dell'oggetto su cui e'
      chiamato.*/
  virtual TelepatiPkg* clone();

  /** Ritorna un array che rappresenta l'oggetto. Costruisce un array
      che rappresenta l'oggetto, l'array corrisponde ai dati spediti
      via rete. @return array di byte. @see TimeInfoPkg(byte* ptr)*/
  byte* getMsg();  

  /** Ritorna il tempo. Restituisce il tempo memorizzato nel
      messaggio @return tempo*/
  inline SystemTime getTime() {return SystemTime(seconds, useconds); };
  /** Imposta il Tempo. Imposta il tempo del messaggio. @param time
      nuovo tempo da memorizzare.*/
  inline void setTime(const SystemTime& time) { 
    seconds=time.seconds; 
    useconds=time.useconds; };

 protected:
  /** Tempo in secondi*/
  longword seconds;
  /** Tempo in microsecondi*/
  longword useconds;
};

#endif
