#include "AiboEdgeDetector.h"
#include <stdlib.h>

AiboEdgeDetector::AiboEdgeDetector(int width, int height) :
  mIAmValid(true),
  mWidth(width),
  mHeight(height),
  mImageSize(mWidth*mHeight),
  mProcessedImage(0),
  mSomeWidth(5*width+1)
{
  mProcessedImage=new unsigned char[mImageSize];
}

AiboEdgeDetector::~AiboEdgeDetector(){
  if(mProcessedImage != 0)
    delete mProcessedImage;
}

const unsigned char* AiboEdgeDetector::getMagnitude(unsigned char* pImage){
    if(mIAmValid)
    {
      int line=0;
      char* ptrSpeedup=reinterpret_cast<char*>(pImage-1);
      
      int gradx, grady, mag;

      for(int i=0; i < mImageSize; i++)
	{
	  // Una volta completata una linea
	  if(line == mWidth-1)
	    {
	      ptrSpeedup += mSomeWidth;
	      line =0;
	    }
	  else
	    {
	      ++ptrSpeedup;
	      ++line;
	    }
	  
	  gradx=*(ptrSpeedup+(4*mWidth));
	  grady=*(ptrSpeedup+(3*mWidth));
	  mag=abs(gradx) + abs(grady);
	  //int a=*(ptrSpeedup+(5*mWidth));
	  if(mag > 255)
	    mag=255;

	  mProcessedImage[i]=(255-mag)*2;
	}
      
    }
    return mProcessedImage;
}

const  char* AiboEdgeDetector::getGradientX(unsigned char* pImage){
    if(mIAmValid)
    {
      int line=0;
      char* ptrSpeedup=reinterpret_cast<char*>(pImage-1);
      
      for(int i=0; i < mImageSize; i++)
	{
	  // Una volta completata una linea
	  if(line == mWidth-1)
	    {
	      ptrSpeedup += mSomeWidth;
	      line =0;
	    }
	  else
	    {
	      ++ptrSpeedup;
	      ++line;
	    }
	  mProcessedImage[i]=*(ptrSpeedup+(4*mWidth));
	}
      
    }
    return reinterpret_cast<char*>(mProcessedImage);
}

const  char* AiboEdgeDetector::getGradientY(unsigned char* pImage){
    if(mIAmValid)
    {
      int line=0;
      char* ptrSpeedup=reinterpret_cast<char*>(pImage-1);
      
      for(int i=0; i < mImageSize; i++)
	{
	  // Una volta completata una linea
	  if(line == mWidth-1)
	    {
	      ptrSpeedup += mSomeWidth;
	      line =0;
	    }
	  else
	    {
	      ++ptrSpeedup;
	      ++line;
	    }
	  mProcessedImage[i]=*(ptrSpeedup+(3*mWidth));
	}
      
    }
    return reinterpret_cast<char*>(mProcessedImage);
}
