#ifndef BREAKTHELINEPKG_H_DEF
#define BREAKTHELINEPKG_H_DEF

#include "TelepatiPkg.h"

using namespace std;

/**implementa il messaggio Rompete le righe.
   Mandato dal Leader al raggiungimento del Goal, quindi alla fine dei comandi.
   Struttura: header standard.
*/

class BreakTheLinePkg : public TelepatiPkg{
 public:
  /** Costruttore ordinario. @param a aibo di destinazione. @param ack se richiede l'Ack o meno.*/
  BreakTheLinePkg(int a, bool ack);
  /**Costruisce l'oggetto a partire dall'array restituito da
     getMsg(). @param ptr puntatore all'array di byte. @see
     getMsg()*/
  BreakTheLinePkg(byte* ptr);

  /** Distruttore di Default.*/
  virtual ~BreakTheLinePkg();

  /** Clonatore. Restituisce un clone dell'oggetto su cui e'
      chiamato.*/
  virtual TelepatiPkg* clone();

  /** Ritorna un array che rappresenta l'oggetto. Costruisce un array
      che rappresenta l'oggetto, l'array corrisponde ai dati spediti
      via rete. @return array di byte. @see BreakTheLinePkg(byte* ptr)*/
  byte* getMsg();  
};

#endif
