#ifndef OTHLEGSREADYPKG_H_DEF
#define OTHLEGSREADYPKG_H_DEF

#include "TelepatiPkg.h"

using namespace std;

/**implementa il messaggio di Assert Ready per le zampe.
   Rappresenta un Assert Ready per le zampe spedito via rete. Viene spedito dagli Other al Leader quando ricevono l'AR da MoveLegs.
   Struttura: e' composto esclusivamente dall'header standard
*/
class OthLegsReadyPkg : public TelepatiPkg{
 public:
  /** Costruttore ordinario. @param a aibo di destinazione. @param ack
      se richiede o meno l'Ack.*/
  OthLegsReadyPkg(int a, bool ack);
  /**Costruisce l'oggetto a partire dall'array restituito da
     getMsg(). @param ptr puntatore all'array di byte. @see
     getMsg()*/
  OthLegsReadyPkg(byte* ptr);

  /** Distruttore di Default.*/
  virtual ~OthLegsReadyPkg();

  /** Clonatore. Restituisce un clone dell'oggetto su cui e'
      chiamato.*/
  virtual TelepatiPkg* clone();

  /** Ritorna un array che rappresenta l'oggetto. Costruisce un array
      che rappresenta l'oggetto, l'array corrisponde ai dati spediti
      via rete. @return array di byte. @see OthLegsReadyPkg(byte* ptr)*/
  byte* getMsg();  
};

#endif
