#include "TimeInfoPkg.h"
#include <SystemTime.h>
#include <time.h>

TimeInfoPkg::TimeInfoPkg(int a, const SystemTime& time, bool ack) : TelepatiPkg(){
  type=TIMEINFO;
  aibo=a;
  needAck=ack;
  seconds=time.seconds;
  useconds=time.useconds;
}

TimeInfoPkg::TimeInfoPkg(byte* ptr) : TelepatiPkg(ptr){
  memcpy(&seconds, (ptr+STD_HEADER_SIZE), sizeof(seconds));  
  memcpy(&useconds, (ptr+STD_HEADER_SIZE+sizeof(seconds)), sizeof(useconds));  
}


TimeInfoPkg::~TimeInfoPkg(){
}

TelepatiPkg* TimeInfoPkg::clone(){
  TimeInfoPkg* clone=new TimeInfoPkg(aibo, SystemTime(seconds, useconds), needAck);
  clone->serialNum=serialNum;
  return clone;
}



byte* TimeInfoPkg::getMsg(){
  delete [] message;
  message=createStdHeader( (sizeof(seconds)+sizeof(useconds)) );
  memcpy((message+STD_HEADER_SIZE), &seconds, sizeof(seconds));  
  memcpy((message+STD_HEADER_SIZE+sizeof(seconds)), &useconds, sizeof(useconds));  
  return message;
}
