//-----------------------------------------
// Include

// Circle fitting lib
#include "CircleFittingClass_Constants.h"

//-----------------------------------------
// Circle fitting class
class CircleFittingClass
{
	//-----------------------------------------
	// Public procedures and variables

	public:

	//-----------------------------------------
	// Constructor, destructor

	CircleFittingClass(void);
	virtual ~CircleFittingClass(void);

	//-----------------------------------------
	// Methods

	void	CircleFittingClass::mResetPoints();
	int		CircleFittingClass::mAddPoint(double X, double Y);

	int		CircleFittingClass::mClusterBaricenterCircleFitting();
	int		CircleFittingClass::mEdgeBaricenterCircleFitting();
	int		CircleFittingClass::mEdgeOMaMaCircleFitting(double Transition);
//	double	CircleFittingClass::_mOMaMaCircleFitting_Computef(Vec_I_DP &x);
int		CircleFittingClass::_mGetNPoints();
	double	CircleFittingClass::mOMaMaCircleFitting_Computef(double CenterX, double CenterY, double Radius);
	int		CircleFittingClass::mOMaMaCircleFitting_DownhillSimplex(double Transition);
	
	double	CircleFittingClass::mGetCenterX();
	double	CircleFittingClass::mGetCenterY();
	double	CircleFittingClass::mGetRadius();
	
	//-----------------------------------------
	// Private procedures and variables

	private:

	//-----------------------------------------
	// Variables

	int			_vNPoints;
	double		_vPoints[_CLASSCIRCLEFITTING_MAXNPOINTS][2];
	double		_vCenterX,_vCenterY;
	double		_vRadius;
	double		_vTransition;

	//-----------------------------------------
	// Methods

	int		CircleFittingClass::_mSetNPoints(int NPoints);
	//messo nei public
	//int		CircleFittingClass::_mGetNPoints();
	int		CircleFittingClass::_mComputeBaricenter();
	double	CircleFittingClass::_mComputeNorm(double X0, double Y0, double X1, double Y1);

	int		CircleFittingClass::_mSimplexSum(double Simplex[4][3], double SimplexSum[3]);
	double	CircleFittingClass::_mAmoTry(double p[4][3], double y[4], double psum[4], int ihi, const double fac);
	void	CircleFittingClass::_mSwap(double *Value0, double *Value1);
};
